Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:47 2008
FILE NAME: i.lpj_establish.f90
PROGRAM NAME: lpj_establish
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   169  vec  (   3): Unvectorized loop.
   169  vec  (  13): Overhead of loop division is too large.
   173  vec  (   4): Vectorized array expression.
   177  vec  (   4): Vectorized array expression.
   187  opt  (1408): Loop switched.
   187  vec  (   4): Vectorized array expression.
   187  vec  (   4): Vectorized array expression.
   187  vec  (   4): Vectorized array expression.
   187  vec  (   4): Vectorized array expression.
   196  vec  (   3): Unvectorized loop.
   196  vec  (  13): Overhead of loop division is too large.
   202  vec  (   4): Vectorized array expression.
   209  vec  (   4): Vectorized array expression.
   221  vec  (   4): Vectorized array expression.
   223  vec  (   2): Partially vectorized loop.
   223  vec  (  25): Work vectors are used. Size=96byte
   230  vec  (   4): Vectorized array expression.
   246  vec  (   4): Vectorized array expression.
   267  vec  (   4): Vectorized array expression.
   291  opt  (1592): Outer loop unrolled inside inner loop.
   291  vec  (   4): Vectorized array expression.
   308  vec  (   3): Unvectorized loop.
   308  vec  (  13): Overhead of loop division is too large.
   310  opt  (1036): Potential feedback - use directive if OK.
   335  vec  (  22): Dependency unknown. Unvectorizable dependency is assumed.:everywhere
   344  vec  (  22): Dependency unknown. Unvectorizable dependency is assumed.:everywhere
   350  vec  (  22): Dependency unknown. Unvectorizable dependency is assumed.:everywhere
   370  vec  (   4): Vectorized array expression.
   382  vec  (   4): Vectorized array expression.
   399  vec  (   4): Vectorized array expression.
   407  vec  (   4): Vectorized array expression.
   427  vec  (   4): Vectorized array expression.
   430  opt  (1084): Branch out of the loop inhibits optimization.
   430  vec  (   4): Vectorized array expression.
   430  vec  (  26): Macro operation Search.
   432  vec  (   3): Unvectorized loop.
   432  vec  (  13): Overhead of loop division is too large.
   434  vec  (   4): Vectorized array expression.
   449  vec  (   4): Vectorized array expression.
   456  vec  (   4): Vectorized array expression.
   456  vec  (   4): Vectorized array expression.
   456  vec  (   4): Vectorized array expression.
   465  vec  (   4): Vectorized array expression.
   483  vec  (   4): Vectorized array expression.
   485  vec  (   4): Vectorized array expression.
   507  vec  (   4): Vectorized array expression.
   530  opt  (1592): Outer loop unrolled inside inner loop.
   530  vec  (   4): Vectorized array expression.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:35:47 2008
FILE NAME: i.lpj_establish.f90
PROGRAM NAME: lpj_establish
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! establishment routine
     2:            ! Suppose seed pool >> establishment rate.
     3:            !
     4:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/lpj_establish.f90,v 1.8 2007/05/28 14:49:02 ssipsl Exp $
     5:            ! IPSL (2006)
     6:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
     7:            !
     8:            MODULE lpj_establish
     9:            
    10:              ! modules used:
    11:            
    12:              USE ioipsl
    13:              USE stomate_constants
    14:            
    15:              IMPLICIT NONE
    16:            
    17:              ! private & public routines
    18:            
    19:              PRIVATE
    20:              PUBLIC establish,establish_clear
    21:            
    22:                ! first call
    23:                LOGICAL, SAVE                                              :: firstcall = .TRUE.
    24:            CONTAINS
    25:            
    26:            
    27:              SUBROUTINE establish_clear
    28:                firstcall = .TRUE.
    29:              END SUBROUTINE establish_clear
    30:            
    31:              SUBROUTINE establish (npts, dt, PFTpresent, regenerate, &
    32:                                neighbours, resolution, space_nat, need_adjacent, herbivores, &
    33:                                precip_annual, gdd0, lm_lastyearmax, &
    34:                                cn_ind, lai, avail_tree, avail_grass, &
    35:                                leaf_age, leaf_frac, &
    36:                                ind, biomass, age, everywhere, co2_to_bm)
    37:            
    38:                !
    39:                ! 0 declarations
    40:                !
    41:            
    42:                ! 0.1 input
    43:            
    44:                ! Domain size
    45:                INTEGER(i_std), INTENT(in)                                  :: npts
    46:                ! Time step of vegetation dynamics (days)
    47:                REAL(r_std), INTENT(in)                                     :: dt
    48:                ! Is pft there
    49:                LOGICAL, DIMENSION(npts,npft), INTENT(in)                  :: PFTpresent
    50:                ! Winter sufficiently cold
    51:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: regenerate
    52:                ! indices of the 8 neighbours of each grid point (1=N, 2=NE, 3=E, 4=SE, 5=S, 6=SW, 7=W, 8=NW)
    53:                INTEGER(i_std), DIMENSION(npts,8), INTENT(in)               :: neighbours
    54:                ! resolution at each grid point in m (1=E-W, 2=N-S)
    55:                REAL(r_std), DIMENSION(npts,2), INTENT(in)                  :: resolution
    56:                ! total natural space (fraction of total space)
    57:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: space_nat
    58:                ! in order for this PFT to be introduced, does it have to be present in an
    59:                !   adjacent grid box?
    60:                LOGICAL, DIMENSION(npts,npft), INTENT(in)                  :: need_adjacent
    61:                ! time constant of probability of a leaf to be eaten by a herbivore (days)
    62:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: herbivores
    63:                ! annual precipitation (mm/year)
    64:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: precip_annual
    65:                ! growing degree days (C)
    66:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: gdd0
    67:                ! last year's maximum leaf mass, for each PFT (gC/(m**2 of nat/agri ground))
    68:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: lm_lastyearmax
    69:                ! crown area of individuals (m**2)
    70:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: cn_ind
    71:                ! leaf area index OF AN INDIVIDUAL PLANT
    72:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: lai
    73:                ! space availability for trees
    74:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: avail_tree
    75:                ! space availability for grasses
    76:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: avail_grass
    77:            
    78:                ! 0.2 modified fields
    79:            
    80:                ! leaf age (days)
    81:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)  :: leaf_age
    82:                ! fraction of leaves in leaf age class
    83:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)  :: leaf_frac
    84:                ! Number of individuals / m2
    85:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)            :: ind
    86:                ! biomass (gC/(m**2 of nat/agri ground))
    87:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)     :: biomass
    88:                ! mean age (years)
    89:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)            :: age
    90:                ! is the PFT everywhere in the grid box or very localized (after its introduction)
    91:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)            :: everywhere
    92:                ! biomass uptaken (gC/(m**2 of total ground)/day)
    93:                REAL(r_std), DIMENSION(npts), INTENT(inout)                 :: co2_to_bm
    94:            
    95:                ! 0.3 local
    96:            
    97:                ! time during which a sapling can be entirely eaten by herbivores (d)
    98:                REAL(r_std)                                                 :: tau_eatup 
    99:                ! new fpc ( foliage protected cover: fractional coverage )
   100:                REAL(r_std), DIMENSION(npts,npft)                           :: fpc_nat
   101:                ! maximum tree establishment rate, based on climate only
   102:                REAL(r_std), DIMENSION(npts)                                :: estab_rate_max_climate_tree
   103:                ! maximum grass establishment rate, based on climate only
   104:                REAL(r_std), DIMENSION(npts)                                :: estab_rate_max_climate_grass
   105:                ! maximum tree establishment rate, based on climate and fpc
   106:                REAL(r_std), DIMENSION(npts)                                :: estab_rate_max_tree
   107:                ! maximum grass establishment rate, based on climate and fpc
   108:                REAL(r_std), DIMENSION(npts)                                :: estab_rate_max_grass
   109:                ! total natural fpc
   110:                REAL(r_std), DIMENSION(npts)                                :: sumfpc
   111:                ! total woody fpc
   112:                REAL(r_std), DIMENSION(npts)                                :: sumfpc_wood
   113:                ! for trees, measures the total concurrence for available space
   114:                REAL(r_std), DIMENSION(npts)                                :: spacefight_tree
   115:                ! for grasses, measures the total concurrence for available space
   116:                REAL(r_std), DIMENSION(npts)                                :: spacefight_grass
   117:                ! change in number of individuals /m2 per time step (per day in history file)
   118:                REAL(r_std), DIMENSION(npts,npft)                           :: d_ind
   119:                ! biomass increase (gC/(m**2 of nat/agri ground))
   120:                REAL(r_std), DIMENSION(npts)                                :: bm_new
   121:                ! stem diameter (m)
   122:                REAL(r_std), DIMENSION(npts)                                :: dia
   123:                ! temporary variable
   124:                REAL(r_std), DIMENSION(npts)                                :: b1
   125:                ! new sap mass (gC/(m**2 of nat/agri ground))
   126:                REAL(r_std), DIMENSION(npts)                                :: sm2
   127:                ! woodmass of an individual
   128:                REAL(r_std), DIMENSION(npts)                                :: woodmass
   129:                ! ratio of hw(above) to total hw, sm(above) to total sm
   130:                REAL(r_std), DIMENSION(npts)                                :: sm_at
   131:                ! reduction factor for establishment if many trees or grasses are present
   132:                REAL(r_std), DIMENSION(npts)                                :: factor
   133:                ! from how many sides is the grid box invaded
   134:                INTEGER(i_std)                                              :: nfrontx
   135:                INTEGER(i_std)                                              :: nfronty
   136:                ! daily establishment rate is large compared to present number of individuals
   137:                LOGICAL, DIMENSION(npts)                                   :: many_new
   138:                ! indices
   139:                INTEGER(i_std)                                              :: i,j,k,m
   140:            
   141:                ! =========================================================================
   142:            
   143:                IF (bavard.GE.3) WRITE(numout,*) 'Entering establish'
   144:            
   145:                !
   146:                ! 1 messages and initialization
   147:                !
   148:                tau_eatup = one_year/2.
   149:            
   150:                IF ( firstcall ) THEN
   151:            
   152:                  WRITE(numout,*) 'establish:'
   153:            
   154:                  WRITE(numout,*) '   > time during which a sapling can be entirely eaten by herbivores (d): ', &
   155:                                      tau_eatup
   156:            
   157:                  firstcall = .FALSE.
   158:            
   159:                ENDIF
   160:            
   161:                !
   162:                ! 2 recalculate fpc
   163:                !
   164:            
   165:                !
   166:                ! 2.1 Only natural part of the grid cell
   167:                !
   168:            
   169: +------>       DO j = 1, npft
   170: |          
   171: |                IF ( natural(j) ) THEN
   172: |          
   173: |V=====            fpc_nat(:,j) = cn_ind(:,j) * ind(:,j) * ( 1. - exp( -lai(:,j) * ext_coeff(j) ) )
   174: |          
   175: |                ELSE
   176: |          
   177: |V=====            fpc_nat(:,j) = 0.0
   178: |          
   179: |                ENDIF
   180: |          
   181: +------        ENDDO
   182:            
   183:                !
   184:                ! 2.2 total natural fpc on grid
   185:                !
   186:            
   187: +V----->       sumfpc(:) = SUM( fpc_nat(:,:), DIM=2 )
   188: |          
   189: |              !
   190: |              ! 2.3 total woody fpc on grid and number of regenerative tree pfts
   191: |              !
   192: |          
   193: |              sumfpc_wood(:) = 0.0
   194: +------        spacefight_tree(:) = 0.0
   195:            
   196: +------>       DO j = 1, npft
   197: |          
   198: |                IF ( tree(j) .AND. natural(j) ) THEN
   199: |          
   200: |                  ! total woody fpc
   201: |          
   202: |V----->           WHERE ( PFTpresent(:,j) )
   203: |V-----              sumfpc_wood(:) = sumfpc_wood(:) + fpc_nat(:,j)
   204: |                  ENDWHERE
   205: |          
   206: |                  ! how many trees are competing? Count a PFT fully only if it is present
   207: |                  !   on the whole grid box.
   208: |          
   209: |V----->           WHERE ( PFTpresent(:,j) .AND. ( regenerate(:,j) .GT. regenerate_crit ) )
   210: |V-----              spacefight_tree(:) = spacefight_tree(:) + everywhere(:,j)
   211: |                  ENDWHERE
   212: |          
   213: |                ENDIF
   214: |          
   215: +------        ENDDO
   216:            
   217:                !
   218:                ! 2.4 number of natural grasses
   219:                !
   220:            
   221: V======        spacefight_grass(:) = 0.0
   222:            
   223: V------>       DO j = 1, npft
   224: |          
   225: |       S        IF ( .NOT. tree(j) .AND. natural(j) ) THEN
   226: |          
   227: |                  ! how many grasses are competing? Count a PFT fully only if it is present
   228: |                  !   on the whole grid box.
   229: |          
   230: |V----->           WHERE ( PFTpresent(:,j) )
   231: |V-----              spacefight_grass(:) = spacefight_grass(:) + everywhere(:,j)
   232: |                  ENDWHERE
   233: |          
   234: |                ENDIF
   235: |          
   236: V------        ENDDO
   237:            
   238:                !
   239:                ! 3 establishment rate
   240:                !
   241:            
   242:                !
   243:                ! 3.1 maximum establishment rate, based on climate only
   244:                !
   245:            
   246: V------>       WHERE ( ( precip_annual(:) .GE. precip_crit ) .AND. ( gdd0(:) .GE. gdd_crit ) )
   247: |          
   248: |                estab_rate_max_climate_tree(:) = estab_max_tree
   249: |                estab_rate_max_climate_grass(:) = estab_max_grass
   250: |          
   251: |              ELSEWHERE
   252: |          
   253: |                estab_rate_max_climate_tree(:) = 0.0
   254: V------          estab_rate_max_climate_grass(:) = 0.0
   255:            
   256:                ENDWHERE
   257:            
   258:                !
   259:                ! 3.2 reduce maximum tree establishment rate if many trees present.
   260:                !     In the original DGVM, this is done using a step function which yields a
   261:                !     reduction by factor 4 if sumfpc_wood(i) .GT.  fpc_crit - 0.05.
   262:                !     This can lead to small oscillations (without consequences however).
   263:                !     Here, a steady linear transition is used between fpc_crit-0.075 and
   264:                !     fpc_crit-0.025.
   265:                !
   266:            
   267: V------>       factor(:) = 1. - 15. * ( sumfpc_wood(:) - (fpc_crit-.075) )
   268: |              factor(:) = MAX( 0.25_r_std, MIN( 1._r_std, factor(:) ) )
   269: |          
   270: |              estab_rate_max_tree(:) = estab_rate_max_climate_tree(:) * factor(:)
   271: |          
   272: |              !
   273: |              ! 3.3 Modulate grass establishment rate.
   274: |              !     If canopy is not closed (fpc < fpc_crit-0.05), normal establishment.
   275: |              !     If canopy is closed, establishment is reduced by a factor 4.
   276: |              !     Factor is linear between these two bounds.
   277: |              !     This is different from the original DGVM where a step function is
   278: |              !     used at fpc_crit-0.05 (This can lead to small oscillations,
   279: |              !     without consequences however).
   280: |              !
   281: |          
   282: |              factor(:) = 1. - 15. * ( sumfpc(:) - (fpc_crit-.05) )
   283: |              factor(:) = MAX( 0.25_r_std, MIN( 1._r_std, factor(:) ) )
   284: |          
   285: V------        estab_rate_max_grass(:) = estab_rate_max_climate_grass(:) * factor(:)
   286:            
   287:                !
   288:                ! 4 do establishment for natural PFTs
   289:                !
   290:            
   291: +V=====        d_ind(:,:) = 0.0
   292:            
   293: +------>       DO j = 1, npft
   294: |          
   295: |                ! only for natural PFTs
   296: |          
   297: |                IF ( natural(j) ) THEN
   298: |          
   299: |                  !
   300: |                  ! 4.1 PFT expansion across the grid box. Not to be confused with areal
   301: |                  !     coverage.
   302: |                  !
   303: |          
   304: |                  IF ( treat_expansion ) THEN
   305: |          
   306: |                    ! only treat plants that are regenerative and present and still can expand
   307: |          
   308: |+----->             DO i = 1, npts
   309: ||         
   310: ||                     IF ( PFTpresent(i,j) .AND. &
   311: ||                          ( everywhere(i,j) .LT. 1. ) .AND. &
   312: ||                           ( regenerate(i,j) .GT. regenerate_crit ) ) THEN
   313: ||         
   314: ||                       ! from how many sides is the grid box invaded (separate x and y directions
   315: ||                       ! because resolution may be strongly anisotropic)
   316: ||                       !
   317: ||                       ! For the moment we only look into 4 direction but that can be extanded (JP) 
   318: ||                       !
   319: ||                       nfrontx = 0
   320: ||                       IF ( neighbours(i,3) .GT. 0 ) THEN
   321: ||                         IF ( everywhere(neighbours(i,3),j) .GT. 1.-min_stomate ) nfrontx = nfrontx+1
   322: ||                       ENDIF
   323: ||                       IF ( neighbours(i,7) .GT. 0 ) THEN
   324: ||                         IF ( everywhere(neighbours(i,7),j) .GT. 1.-min_stomate ) nfrontx = nfrontx+1
   325: ||                       ENDIF
   326: ||         
   327: ||                       nfronty = 0
   328: ||                       IF ( neighbours(i,1) .GT. 0 ) THEN
   329: ||                         IF ( everywhere(neighbours(i,1),j) .GT. 1.-min_stomate ) nfronty = nfronty+1
   330: ||                       ENDIF
   331: ||                       IF ( neighbours(i,5) .GT. 0 ) THEN
   332: ||                         IF ( everywhere(neighbours(i,5),j) .GT. 1.-min_stomate ) nfronty = nfronty+1
   333: ||                       ENDIF
   334: ||         
   335: ||                       everywhere(i,j) = &
   336: ||                       everywhere(i,j) + migrate(j) * dt/one_year * &
   337: ||                                         ( nfrontx / resolution(i,1) + nfronty / resolution(i,2) )
   338: ||         
   339: ||                       IF ( .NOT. need_adjacent(i,j) ) THEN
   340: ||         
   341: ||                         ! in that case, we also assume that the PFT expands from places within
   342: ||                         ! the grid box (e.g., oasis).
   343: ||         
   344: ||                         everywhere(i,j) = &
   345: ||                         everywhere(i,j) + migrate(j) * dt/one_year * &
   346: ||                              2. * SQRT( pi*everywhere(i,j)/(resolution(i,1)*resolution(i,2)) )
   347: ||         
   348: ||                       ENDIF
   349: ||         
   350: ||                       everywhere(i,j) = MIN( everywhere(i,j), 1._r_std )
   351: ||         
   352: ||                     ENDIF
   353: ||         
   354: |+-----              ENDDO
   355: |          
   356: |                  ENDIF  ! treat expansion?
   357: |          
   358: |                  !
   359: |                  ! 4.2 establishment rate
   360: |                  !     - Is lower if the PFT is only present in a small part of the grid box
   361: |                  !       (after its introduction), therefore multiplied by "everywhere".
   362: |                  !     - Is divided by the number of PFTs that compete ("spacefight").
   363: |                  !     - Is modulated by space availability (avail_tree, avail_grass).
   364: |                  !
   365: |          
   366: |                  IF ( tree(j) ) THEN
   367: |          
   368: |                    ! 4.2.1 present and regenerative trees
   369: |          
   370: |V----->             WHERE ( PFTpresent(:,j) .AND. ( regenerate(:,j) .GT. regenerate_crit ) )
   371: ||         
   372: ||         
   373: |V-----                d_ind(:,j) = estab_rate_max_tree(:)*everywhere(:,j)/spacefight_tree(:) * &
   374: |                                   avail_tree(:) * dt/one_year
   375: |          
   376: |                    ENDWHERE
   377: |          
   378: |                  ELSE
   379: |          
   380: |                    ! 4.2.2 present and regenerative grasses
   381: |          
   382: |V----->             WHERE ( PFTpresent(:,j) .AND. ( regenerate(:,j) .GT. regenerate_crit ) )
   383: ||         
   384: |V-----                d_ind(:,j) = estab_rate_max_grass(:)*everywhere(:,j)/spacefight_grass(:) * &
   385: |                                   avail_grass(:) * dt/one_year
   386: |          
   387: |                    ENDWHERE
   388: |          
   389: |                  ENDIF  ! tree/grass
   390: |          
   391: |                  !
   392: |                  ! 4.3 herbivores reduce establishment rate
   393: |                  !     We suppose that saplings are vulnerable during a given time after establishment.
   394: |                  !     This is taken into account by preventively reducing the establishment rate.
   395: |                  !
   396: |          
   397: |                  IF ( ok_herbivores ) THEN
   398: |          
   399: |V=====              d_ind(:,j) = d_ind(:,j) * EXP( - tau_eatup/herbivores(:,j) )
   400: |          
   401: |                  ENDIF
   402: |          
   403: |                  !
   404: |                  ! 4.4 be sure that ind*cn_ind does not exceed 1
   405: |                  !
   406: |          
   407: |V----->           WHERE ( ( d_ind(:,j) .GT. 0.0 ) .AND. &
   408: ||                         ( (ind(:,j)+d_ind(:,j))*cn_ind(:,j) .GT. 1. ) )
   409: ||         
   410: |V-----              d_ind(:,j) = MAX( 1._r_std / cn_ind(:,j) - ind(:,j), 0._r_std )
   411: |          
   412: |                  ENDWHERE
   413: |          
   414: |                  !
   415: |                  ! 4.5 new properties where there is establishment ( d_ind > 0 )
   416: |                  !
   417: |          
   418: |                  ! 4.5.1 biomass.
   419: |                  !       Add biomass only if d_ind, over one year, is of the order of ind.
   420: |                  !       (If we don't do this, the biomass density can become very low).
   421: |                  !       In that case, take biomass from the atmosphere.
   422: |                  !       As we are talking about a flux from the atmosphere, we transform
   423: |                  !       space_nat from gC/(m**2 of natural ground) to 
   424: |                  !       gC/(m**2 of total ground).
   425: |          
   426: |                  ! compare establishment rate and present number of inidivuals
   427: |V=====            many_new(:) = ( d_ind(:,j) .GT. 0.1 * ind(:,j) )
   428: |          
   429: |                  ! gives a better vectorization of the VPP
   430: |V=====            IF ( ANY( many_new(:) ) ) THEN
   431: |          
   432: |+----->             DO k = 1, nparts
   433: ||         
   434: ||V---->               WHERE ( many_new(:) )
   435: |||        
   436: |||                      bm_new(:) = d_ind(:,j) * bm_sapl(j,k)
   437: |||        
   438: |||                      biomass(:,j,k) = biomass(:,j,k) + bm_new(:)
   439: |||        
   440: ||V----                  co2_to_bm(:) = co2_to_bm(:) + bm_new(:) * space_nat(:) / dt
   441: ||         
   442: ||                     ENDWHERE
   443: ||         
   444: |+-----              ENDDO
   445: |          
   446: |                    ! reset leaf ages. Should do a real calculation like in the npp routine, 
   447: |                    ! but this case is rare and not worth messing around.
   448: |          
   449: |V----->             WHERE ( many_new(:) )
   450: ||                     leaf_age(:,j,1) = 0.0
   451: |V-----                leaf_frac(:,j,1) = 1.0
   452: |                    ENDWHERE
   453: |          
   454: |*----->             DO m = 2, nleafages
   455: ||         
   456: ||V---->               WHERE ( many_new(:) )
   457: |||                      leaf_age(:,j,m) = 0.0
   458: ||V----                  leaf_frac(:,j,m) = 0.0
   459: ||                     ENDWHERE
   460: ||         
   461: |*-----              ENDDO
   462: |          
   463: |                  ENDIF   ! establishment rate is large
   464: |          
   465: |V----->           WHERE ( d_ind(:,j) .GT. 0.0 )
   466: ||         
   467: ||                   ! 4.5.2 age decreases
   468: ||         
   469: ||                   age(:,j) = age(:,j) * ind(:,j) / ( ind(:,j) + d_ind(:,j) )
   470: ||         
   471: ||                   ! 4.5.3 new number of individuals
   472: ||         
   473: |V-----              ind(:,j) = ind(:,j) + d_ind(:,j)
   474: |          
   475: |                  ENDWHERE
   476: |          
   477: |                  !
   478: |                  ! 4.6 eventually convert excess sapwood to heartwood
   479: |                  !
   480: |          
   481: |                  IF ( tree(j) ) THEN
   482: |          
   483: |V=====              sm2(:) = 0.0
   484: |          
   485: |V----->             WHERE ( d_ind(:,j) .GT. 0.0 ) 
   486: ||         
   487: ||                     ! ratio of above / total sap parts
   488: ||                     sm_at(:) = biomass(:,j,isapabove) / &
   489: ||                             ( biomass(:,j,isapabove) + biomass(:,j,isapbelow) )
   490: ||         
   491: ||                     ! woodmass of an individual
   492: ||         
   493: ||                     woodmass(:) = &
   494: ||                       ( biomass(:,j,isapabove) + biomass(:,j,isapbelow) + &
   495: ||                         biomass(:,j,iheartabove) + biomass(:,j,iheartbelow) ) / ind(:,j)
   496: ||         
   497: ||                     ! crown area (m**2) depends on stem diameter (pipe model)
   498: ||                     dia(:) = ( woodmass(:) / ( pipe_density * pi/4. * pipe_tune2 ) ) &
   499: ||                                  ** ( 1. / ( 2. + pipe_tune3 ) )
   500: ||         
   501: ||                     b1(:) = pipe_k1 / ( sla(j) * pipe_density*pipe_tune2 * dia(:)**pipe_tune3 ) * &
   502: ||                             ind(:,j)
   503: |V-----                sm2(:) = lm_lastyearmax(:,j) / b1(:)
   504: |          
   505: |                    ENDWHERE
   506: |          
   507: |V----->             WHERE ( ( d_ind(:,j) .GT. 0.0 ) .AND. &
   508: ||                           ( biomass(:,j,isapabove) + biomass(:,j,isapbelow) ) .GT. sm2(:) )
   509: ||         
   510: ||                     biomass(:,j,iheartabove) = biomass(:,j,iheartabove) + &
   511: ||                                                ( biomass(:,j,isapabove) - sm2(:) * sm_at(:) )
   512: ||                     biomass(:,j,isapabove) = sm2(:) * sm_at(:)
   513: ||         
   514: ||                     biomass(:,j,iheartbelow) = biomass(:,j,iheartbelow) + &
   515: ||                                                ( biomass(:,j,isapbelow) - sm2(:) * (1. - sm_at) )
   516: |V-----                biomass(:,j,isapbelow) = sm2(:) * (1. - sm_at(:))
   517: |          
   518: |                    ENDWHERE
   519: |          
   520: |                  ENDIF        ! tree
   521: |          
   522: |                ENDIF          ! natural
   523: |          
   524: +------        ENDDO            ! loop over pfts
   525:            
   526:                !
   527:                ! 5 history
   528:                !
   529:            
   530: +V=====        d_ind = d_ind / dt
   531:            
   532:                CALL histwrite (hist_id_stomate, 'IND_ESTAB', itime, d_ind, npts*npft, horipft_index)
   533:            
   534:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving establish'
   535:            
   536:              END SUBROUTINE establish
   537:            
   538:            END MODULE lpj_establish
