Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:34 2008
FILE NAME: i.stomate_npp.f90
PROGRAM NAME: stomate_npp
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   150  vec  (   4): Vectorized array expression.
   167  opt  (1593): Loop nest collapsed into one loop.
   167  vec  (   4): Vectorized array expression.
   179  vec  (   4): Vectorized array expression.
   185  vec  (   3): Unvectorized loop.
   185  vec  (  13): Overhead of loop division is too large.
   187  vec  (   4): Vectorized array expression.
   199  opt  (1592): Outer loop unrolled inside inner loop.
   199  vec  (   4): Vectorized array expression.
   213  vec  (   4): Vectorized array expression.
   230  vec  (   4): Vectorized array expression.
   232  vec  (   4): Vectorized array expression.
   239  opt  (1082): Backward transfers inhibit loop optimization.
   239  vec  (   4): Vectorized array expression.
   243  vec  (   3): Unvectorized loop.
   245  opt  (1592): Outer loop unrolled inside inner loop.
   245  vec  (   4): Vectorized array expression.
   269  vec  (   4): Vectorized array expression.
   272  warn (   7): Characters in a line over this form limitation 132.
   272  vec  (   3): Unvectorized loop.
   273  vec  (   4): Vectorized array expression.
   287  opt  (1036): Potential feedback - use directive if OK.
   287  vec  (   4): Vectorized array expression.
   289  vec  (   1): Vectorized loop.
   327  vec  (   3): Unvectorized loop.
   328  opt  (1592): Outer loop unrolled inside inner loop.
   328  vec  (   4): Vectorized array expression.
   336  opt  (1036): Potential feedback - use directive if OK.
   336  vec  (   4): Vectorized array expression.
   338  opt  (1592): Outer loop unrolled inside inner loop.
   338  opt  (1592): Outer loop unrolled inside inner loop.
   346  vec  (   4): Vectorized array expression.
   348  vec  (   3): Unvectorized loop.
   349  vec  (   4): Vectorized array expression.
   350  opt  (1592): Outer loop unrolled inside inner loop.
   359  opt  (1592): Outer loop unrolled inside inner loop.
   359  vec  (   4): Vectorized array expression.
   361  opt  (1592): Outer loop unrolled inside inner loop.
   361  vec  (   4): Vectorized array expression.
   371  vec  (   3): Unvectorized loop.
   371  vec  (  13): Overhead of loop division is too large.
   373  vec  (   4): Vectorized array expression.
   389  opt  (1593): Loop nest collapsed into one loop.
   389  vec  (   4): Vectorized array expression.
   407  opt  (1592): Outer loop unrolled inside inner loop.
   407  vec  (   4): Vectorized array expression.
   409  opt  (1592): Outer loop unrolled inside inner loop.
   409  vec  (   4): Vectorized array expression.
   423  opt  (1592): Outer loop unrolled inside inner loop.
   423  vec  (   4): Vectorized array expression.
   433  opt  (1592): Outer loop unrolled inside inner loop.
   433  vec  (   4): Vectorized array expression.
   433  vec  (   4): Vectorized array expression.
   433  vec  (   4): Vectorized array expression.
   449  opt  (1592): Outer loop unrolled inside inner loop.
   449  vec  (   4): Vectorized array expression.
   467  vec  (   3): Unvectorized loop.
   467  vec  (  13): Overhead of loop division is too large.
   476  vec  (   4): Vectorized array expression.
   481  opt  (1082): Backward transfers inhibit loop optimization.
   481  vec  (   4): Vectorized array expression.
   508  warn (  83): Dummy argument "lai" is not used.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:34 2008
FILE NAME: i.stomate_npp.f90
PROGRAM NAME: stomate_npp
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! Npp: Maintenance and growth respiration
     2:            ! We calculte first the maintenance rspiration. This is substracted from the
     3:            ! allocatable biomass (and from the present biomass if the GPP is too low).
     4:            ! Of the rest, a part is lost as growth respiration, while the other part is
     5:            ! effectively allocated.
     6:            !
     7:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_npp.f90,v 1.10 2007/05/28 14:49:02 ssipsl Exp $
     8:            ! IPSL (2006)
     9:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
    10:            !
    11:            MODULE stomate_npp
    12:            
    13:              ! modules used:
    14:            
    15:              USE ioipsl
    16:              USE stomate_constants
    17:              USE stomate_natagritot
    18:            
    19:              IMPLICIT NONE
    20:            
    21:              ! private & public routines
    22:            
    23:              PRIVATE
    24:              PUBLIC npp_calc,npp_calc_clear
    25:            
    26:                ! first call
    27:                LOGICAL, SAVE                                              :: firstcall = .TRUE.
    28:            
    29:            CONTAINS
    30:            
    31:              SUBROUTINE npp_calc_clear
    32:                firstcall=.TRUE.
    33:              END SUBROUTINE npp_calc_clear
    34:            
    35:              SUBROUTINE npp_calc (npts, dt, space_nat, &
    36:                                   PFTpresent, &
    37:                                   tlong_ref, t2m, tsoil, lai, rprof, &
    38:                                   gpp, f_alloc, resp_maint_part,&
    39:                                   biomass, leaf_age, leaf_frac, age, &
    40:                                   resp_maint, resp_growth, npp)
    41:            
    42:                !
    43:                ! 0 declarations
    44:                !
    45:            
    46:                ! 0.1 input
    47:            
    48:                ! Domain size
    49:                INTEGER(i_std), INTENT(in)                                        :: npts
    50:                ! time step (days)
    51:                REAL(r_std), INTENT(in)                                     :: dt
    52:                ! fraction of total space that is natural
    53:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: space_nat
    54:                ! PFT exists
    55:                LOGICAL, DIMENSION(npts,npft), INTENT(in)                  :: PFTpresent
    56:                ! long term annual mean 2 meter reference temperature
    57:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: tlong_ref
    58:                ! 2 meter temperature
    59:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: t2m
    60:                ! soil temperature (K)
    61:                REAL(r_std), DIMENSION(npts,nbdl), INTENT(in)               :: tsoil
    62:                ! leaf area index
    63:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: lai
    64:                ! root depth (m)
    65:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: rprof
    66:                ! gross primary productivity (gC/days/(m**2 of natural/agricultural ground))
    67:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: gpp
    68:                ! fraction that goes into plant part
    69:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(in)        :: f_alloc
    70:                ! maintenance respiration of different plant parts (gC/day/m**2 of nat/agri ground)
    71:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(in)             :: resp_maint_part
    72:            
    73:                ! 0.2 modified fields
    74:            
    75:                ! biomass (gC/(m**2 of natural/agricultural ground))
    76:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)     :: biomass
    77:                ! leaf age (days)
    78:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)  :: leaf_age
    79:                ! fraction of leaves in leaf age class
    80:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)  :: leaf_frac
    81:                ! age (years)
    82:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)            :: age
    83:            
    84:                ! 0.3 output
    85:            
    86:                ! maintenance respiration (gC/day/m**2 of total ground)
    87:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)              :: resp_maint
    88:                ! autotrophic respiration (gC/day/m**2 of total ground)
    89:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)              :: resp_growth
    90:                ! net primary productivity (gC/day/m**2 of natural/agricultural ground)
    91:                REAL(r_std), DIMENSION(npts,npft), INTENT(out)              :: npp
    92:            
    93:                ! 0.4 local
    94:            
    95:                ! maximum fraction of allocatable biomass used for maintenance respiration
    96:                REAL(r_std), PARAMETER                                      :: tax_max = 0.8
    97:                ! soil levels (m)
    98:                REAL(r_std), SAVE, DIMENSION(0:nbdl)                        :: z_soil
    99:                ! root temperature (convolution of root and soil temperature profiles)
   100:                REAL(r_std), DIMENSION(npts,npft)                           :: t_root
   101:                ! maintenance respiration coefficients at 0 deg C (g/g d**-1)
   102:                REAL(r_std), DIMENSION(npts,npft,nparts)                    :: coeff_maint
   103:                ! temperature which is pertinent for maintenance respiration (K)
   104:                REAL(r_std), DIMENSION(npts,nparts)                         :: t_maint
   105:                ! integration constant for root profile
   106:                REAL(r_std), DIMENSION(npts)                                :: rpc
   107:                ! long term annual mean temperature, C
   108:                REAL(r_std), DIMENSION(npts)                                :: tl
   109:                ! slope of maintenance respiration coefficient (1/K)
   110:                REAL(r_std), DIMENSION(npts)                                :: slope
   111:                ! growth respiration of different plant parts (gC/day/m**2 of nat/agri ground)
   112:                REAL(r_std), DIMENSION(npts,nparts)                         :: resp_growth_part
   113:                ! allocatable biomass (gC/m**2 of nat/agri ground) for the whole plant
   114:                REAL(r_std), DIMENSION(npts,npft)                           :: bm_alloc_tot
   115:                ! biomass increase, i.e. NPP per plant part
   116:                REAL(r_std), DIMENSION(npts,npft,nparts)                    :: bm_alloc
   117:                ! biomass increase
   118:                REAL(r_std), DIMENSION(npts)                                :: bm_add
   119:                ! new biomass
   120:                REAL(r_std), DIMENSION(npts)                                :: bm_new
   121:                ! leaf mass in youngest age class (gC/m**2 of nat/agri ground)
   122:                REAL(r_std), DIMENSION(npts,npft)                           :: leaf_mass_young
   123:                ! leaf mass after maintenance respiration
   124:                REAL(r_std), DIMENSION(npts,npft)                           :: lm_old
   125:                ! biomass created when biomass<0 because of dark respiration (gC/m**2 of nat/agri ground)
   126:                REAL(r_std), DIMENSION(npts,npft)                           :: bm_create
   127:                ! maximum part of allocatable biomass used for respiration
   128:                REAL(r_std), DIMENSION(npts)                                :: bm_tax_max
   129:                ! biomass that remains to be taken away
   130:                REAL(r_std), DIMENSION(npts)                                :: bm_pump
   131:                ! Index
   132:                INTEGER(i_std)                                             :: i,j,k,l,m
   133:            
   134:                ! =========================================================================
   135:            
   136:                IF (bavard.GE.3) WRITE(numout,*) 'Entering npp'
   137:                !
   138:                ! 1 Initializations
   139:                !
   140:            
   141:                !
   142:                ! 1.1 first call
   143:                !
   144:            
   145:                IF ( firstcall ) THEN
   146:            
   147:                  ! 1.1.1 soil levels
   148:            
   149:                  z_soil(0) = 0.
   150: V======          z_soil(1:nbdl) = diaglev(1:nbdl)
   151:            
   152:                  ! 1.1.2 messages
   153:            
   154:                  WRITE(numout,*) 'npp:'
   155:            
   156:                  WRITE(numout,*) '   > max. fraction of allocatable biomass used for'// &
   157:                                      ' maint. resp.:', tax_max
   158:            
   159:                  firstcall = .FALSE.
   160:            
   161:                ENDIF
   162:            
   163:                !
   164:                ! 1.2 set output to zero
   165:                !
   166:            
   167: *W----->       resp_maint(:,:) = 0.0
   168: ||             resp_growth(:,:) = 0.0
   169: *W-----        npp(:,:) = 0.0
   170:            
   171:                !
   172:                ! 1.3 root temperature: convolution of root and temperature profiles
   173:                !     suppose exponential root profile.
   174:                !
   175:            
   176: +------>       DO j = 1, npft
   177: |          
   178: |                ! 1.3.1 rpc is an integration constant such that the integral of the root profile is 1.
   179: |V----->         rpc(:) = 1. / ( 1. - EXP( -z_soil(nbdl) / rprof(:,j) ) )
   180: ||         
   181: ||               ! 1.3.2 integrate over the nbdl levels
   182: ||         
   183: |V-----          t_root(:,j) = 0.0
   184: |          
   185: |+----->         DO l = 1, nbdl
   186: ||         
   187: ||V====            t_root(:,j) = &
   188: ||                   t_root(:,j) + tsoil(:,l) * rpc(:) * &
   189: ||                                 ( EXP( -z_soil(l-1)/rprof(:,j) ) - EXP( -z_soil(l)/rprof(:,j) ) )
   190: ||         
   191: |+-----          ENDDO
   192: |          
   193: +------        ENDDO
   194:            
   195:                !
   196:                ! 1.4 total allocatable biomass
   197:                !
   198:            
   199: +V=====        bm_alloc_tot(:,:) = gpp(:,:) * dt
   200:            
   201:                !
   202:                ! 2 define maintenance respiration coefficients
   203:                !
   204:            
   205: +------>       DO j = 1, npft
   206: |            
   207: |                !
   208: |                ! 2.1 temperature which is taken for the plant part we are talking about
   209: |                !
   210: |          
   211: |                ! 2.1.1 parts above the ground
   212: |          
   213: |V----->         t_maint(:,ileaf) = t2m(:)
   214: ||               t_maint(:,isapabove) = t2m(:)
   215: ||               t_maint(:,ifruit) = t2m(:)
   216: ||         
   217: ||               ! 2.1.2 parts below the ground
   218: ||         
   219: ||               t_maint(:,isapbelow) = t_root(:,j)
   220: ||               t_maint(:,iroot) = t_root(:,j)
   221: ||         
   222: ||               ! 2.1.3 heartwood: does not respire. Any temperature
   223: ||         
   224: ||               t_maint(:,iheartbelow) = t_root(:,j)
   225: |V-----          t_maint(:,iheartabove) = t2m(:)
   226: |          
   227: |                ! 2.1.4 reserve: above the ground for trees, below for grasses
   228: |          
   229: |                IF ( tree(j) ) THEN
   230: |V=====            t_maint(:,icarbres) = t2m(:)
   231: |                ELSE
   232: |V=====            t_maint(:,icarbres) = t_root(:,j)
   233: |                ENDIF
   234: |          
   235: |                !
   236: |                ! 2.2 calculate coefficient
   237: |                !
   238: |          
   239: |V----->         tl(:) = tlong_ref(:) - ZeroCelsius
   240: |V-----          slope(:) = maint_resp_slope(j,1) + tl(:) * maint_resp_slope(j,2) + &
   241: |                           tl(:)*tl(:) * maint_resp_slope(j,3)
   242: |          
   243: |+----->         DO k = 1, nparts
   244: ||           
   245: ||V====            coeff_maint(:,j,k) = &
   246: ||                   MAX( coeff_maint_zero(j,k) * &
   247: ||                            ( 1. + slope(:) * (t_maint(:,k)-ZeroCelsius) ), 0._r_std )
   248: ||         
   249: |+-----          ENDDO
   250: |              
   251: +------        ENDDO
   252:            
   253:                !
   254:                ! 3 calculate maintenance and growth respiration.
   255:                !   NPP = GPP - maintenance resp - growth resp.
   256:                !
   257:            
   258: +------>       DO j = 1, npft
   259: |          
   260: |                !
   261: |                ! 3.1 maintenance respiration of the different plant parts
   262: |                !
   263: |                !
   264: |                ! 3.2 Total maintenance respiration of the plant
   265: |                !     VPP killer:
   266: |                !     resp_maint(:,j) = SUM( resp_maint_part(:,:), DIM=2 )
   267: |                !
   268: |          
   269: |V=====          resp_maint(:,j) = 0.0
   270: |          
   271: |               !with the new calculation of hourly respiration, we must verify that PFT as not been killed after calcul of resp_maint_part in stomate
   272: |+----->            DO k= 1, nparts
   273: ||V---->               WHERE (PFTpresent(:,j))
   274: ||V----                   resp_maint(:,j) = resp_maint(:,j) + resp_maint_part(:,j,k)
   275: ||                     ENDWHERE
   276: |+-----             ENDDO
   277: |                !
   278: |                ! 3.3 This maintenance respiration is taken away from the newly produced 
   279: |                !     allocatable biomass. However, we avoid that no allocatable biomass remains.
   280: |                !     If the respiration is larger than a given fraction of the allocatable biomass,
   281: |                !     the rest is taken from the tissues themselves.
   282: |                !     We suppose that respiration is not dependent on leaf age -> 
   283: |                !     do not change age structure.
   284: |                !
   285: |          
   286: |                ! maximum part of allocatable biomass used for respiration
   287: |V=====          bm_tax_max(:) = tax_max * bm_alloc_tot(:,j)
   288: |          
   289: |V----->         DO i = 1, npts
   290: ||         
   291: ||                 IF ( ( bm_alloc_tot(i,j) .GT. 0.0 ) .AND. &
   292: ||                       ( ( resp_maint(i,j) * dt ) .LT. bm_tax_max(i) ) ) THEN
   293: ||         
   294: ||                   bm_alloc_tot(i,j) = bm_alloc_tot(i,j) - resp_maint(i,j) * dt
   295: ||         
   296: ||                 ELSEIF ( resp_maint(i,j) .GT. 0.0 ) THEN
   297: ||         
   298: ||                   ! remaining allocatable biomass
   299: ||                   bm_alloc_tot(i,j) = bm_alloc_tot(i,j) - bm_tax_max(i)
   300: ||           
   301: ||                   ! biomass that remains to be taken away from tissues
   302: ||                   bm_pump(i) = resp_maint(i,j) * dt - bm_tax_max(i)
   303: ||           
   304: ||                   ! take biomass from tissues
   305: ||           
   306: ||                   biomass(i,j,ileaf) = biomass(i,j,ileaf) - &
   307: ||                                        bm_pump(i) * resp_maint_part(i,j,ileaf) / resp_maint(i,j)
   308: ||                   biomass(i,j,isapabove) = biomass(i,j,isapabove) - &
   309: ||                                            bm_pump(i) * resp_maint_part(i,j,isapabove) / resp_maint(i,j)
   310: ||                   biomass(i,j,isapbelow) = biomass(i,j,isapbelow) - &
   311: ||                                            bm_pump(i) * resp_maint_part(i,j,isapbelow) / resp_maint(i,j)
   312: ||                   biomass(i,j,iroot) = biomass(i,j,iroot) - &
   313: ||                                        bm_pump(i) * resp_maint_part(i,j,iroot) / resp_maint(i,j)
   314: ||                   biomass(i,j,ifruit) = biomass(i,j,ifruit) - &
   315: ||                                         bm_pump(i) * resp_maint_part(i,j,ifruit) / resp_maint(i,j)
   316: ||                   biomass(i,j,icarbres) = biomass(i,j,icarbres) - &
   317: ||                                           bm_pump(i) * resp_maint_part(i,j,icarbres) / resp_maint(i,j)
   318: ||         
   319: ||                 ENDIF
   320: ||         
   321: |V-----          ENDDO   ! Fortran95: WHERE - ELSEWHERE construct
   322: |          
   323: |                !
   324: |                ! 3.4 dispatch allocatable biomass
   325: |                !
   326: |          
   327: |+----->         DO k = 1, nparts
   328: ||V====            bm_alloc(:,j,k) = f_alloc(:,j,k) * bm_alloc_tot(:,j)
   329: |+-----          ENDDO
   330: |          
   331: |                !
   332: |                ! 3.5 growth respiration of a plant part is a given fraction of the
   333: |                !     remaining allocatable biomass.
   334: |                !
   335: |          
   336: |*V---->         resp_growth_part(:,:) = frac_growthresp * bm_alloc(:,j,:) / dt
   337: |||        
   338: |*V----          bm_alloc(:,j,:) = ( 1. - frac_growthresp ) * bm_alloc(:,j,:)
   339: |          
   340: |                !
   341: |                ! 3.6 Total growth respiration of the plant
   342: |                !     VPP killer:
   343: |                !     resp_growth(:,j) = SUM( resp_growth_part(:,:), DIM=2 )
   344: |                !
   345: |          
   346: |V=====          resp_growth(:,j) = 0.0
   347: |          
   348: |+----->         DO k = 1, nparts
   349: ||V====            resp_growth(:,j) = resp_growth(:,j) + resp_growth_part(:,k)
   350: |+-----          ENDDO
   351: |          
   352: +------        ENDDO
   353:            
   354:                !
   355:                ! 4 update the biomass, but save the old leaf mass for later
   356:                !   "old" leaf mass is leaf mass after maintenance respiration
   357:                !
   358:            
   359: +V=====        lm_old(:,:) = biomass(:,:,ileaf)
   360:            
   361: ++V====        biomass(:,:,:) = biomass(:,:,:) + bm_alloc(:,:,:)
   362:            
   363:                !
   364:                ! 5 biomass can become negative in some rare cases, as the GPP can be negative
   365:                !   (dark respiration).
   366:                !   In this case, set biomass to some small value. This creation of matter is taken into
   367:                !   account by decreasing the autotrophic respiration. In this case, maintenance respiration
   368:                !   can become negative !!!
   369:                ! 
   370:            
   371: +------>       DO k = 1, nparts
   372: |          
   373: |*V---->         WHERE ( biomass(:,:,k) .LT. 0.0 )
   374: |||        
   375: |||                bm_create(:,:) = min_stomate - biomass(:,:,k)
   376: |||        
   377: |||                biomass(:,:,k) = biomass(:,:,k) + bm_create(:,:)
   378: |||        
   379: |*V----            resp_maint(:,:) = resp_maint(:,:) - bm_create(:,:) / dt
   380: |          
   381: |                ENDWHERE
   382: |          
   383: +------        ENDDO
   384:            
   385:                !
   386:                ! 6 Calculate the NPP (gC/(m**2 of nat/agri ground/day)
   387:                !
   388:            
   389: W+=====        npp(:,:) = gpp(:,:) - resp_growth(:,:) - resp_maint(:,:)
   390:            
   391:                !
   392:                ! 7 transform respiration from gC/(m**2 of nat/agri ground)/day) into
   393:                !   gC/(m**2 of total ground)/day), as it goes into the atmosphere.
   394:                !
   395:            
   396:                CALL natagritot (npts, ito_total, space_nat, resp_maint)
   397:                CALL natagritot (npts, ito_total, space_nat, resp_growth)
   398:            
   399:                !
   400:                ! 8 leaf age
   401:                !
   402:            
   403:                !
   404:                ! 8.1 Decrease leaf age in youngest class if new leaf biomass is higher than old one.
   405:                !
   406:            
   407: +V=====        leaf_mass_young(:,:) = leaf_frac(:,:,1) * lm_old(:,:) + bm_alloc(:,:,ileaf)
   408:            
   409: *V----->       WHERE ( ( bm_alloc(:,:,ileaf) .GT. 0.0 ) .AND. &
   410: ||                     ( leaf_mass_young(:,:) .GT. 0.0 ) )
   411: ||         
   412: *V-----          leaf_age(:,:,1) = leaf_age(:,:,1) * ( leaf_mass_young(:,:) - bm_alloc(:,:,ileaf) ) / &
   413:                                                        leaf_mass_young(:,:)
   414:            
   415:                ENDWHERE
   416:            
   417:                !
   418:                ! 8.2 new age class fractions (fraction in youngest class increases)
   419:                !
   420:            
   421:                ! 8.2.1 youngest class: new mass in youngest class divided by total new mass
   422:            
   423: *V----->       WHERE ( biomass(:,:,ileaf) .GT. min_stomate )
   424: ||         
   425: *V-----          leaf_frac(:,:,1) = leaf_mass_young(:,:) / biomass(:,:,ileaf)
   426:            
   427:                ENDWHERE
   428:            
   429:                ! 8.2.2 other classes: old mass in leaf age class divided by new mass
   430:            
   431: *------>       DO m = 2, nleafages
   432: |          
   433: |*V---->         WHERE ( biomass(:,:,ileaf) .GT. min_stomate )
   434: |||        
   435: |*V----            leaf_frac(:,:,m) = leaf_frac(:,:,m) * lm_old(:,:) / biomass(:,:,ileaf)
   436: |          
   437: |                ENDWHERE
   438: |          
   439: *------        ENDDO
   440:            
   441:                !
   442:                ! 9 Plant age (years)
   443:                !
   444:            
   445:                !
   446:                ! 9.1 Increase age at every time step
   447:                !
   448:            
   449: *V----->       WHERE ( PFTpresent(:,:) )
   450: ||         
   451: ||               age(:,:) = age(:,:) + dt/one_year
   452: ||         
   453: ||             ELSEWHERE
   454: ||         
   455: *V-----          age(:,:) = 0.0
   456:            
   457:                ENDWHERE
   458:            
   459:                !
   460:                ! 9.2 For grasses, decrease age
   461:                !     if new biomass is higher than old one.
   462:                !     For trees, age is treated in "establish" if vegetation is dynamic,
   463:                !     and in turnover routines if it is static (in this case, only take 
   464:                !     into account the age of the heartwood).
   465:                !
   466:            
   467: +------>       DO j = 1, npft
   468: |          
   469: |                IF ( .NOT. tree(j) ) THEN
   470: |          
   471: |                  ! Only four compartments for grasses
   472: |                  ! VPP killer:
   473: |                  ! bm_new(:) = SUM( biomass(:,j,:), DIM=2 )
   474: |                  ! bm_add(:) = SUM( bm_alloc(:,j,:), DIM=2 )
   475: |          
   476: |V----->           bm_new(:) = biomass(:,j,ileaf) + biomass(:,j,isapabove) + &
   477: ||                             biomass(:,j,iroot) + biomass(:,j,ifruit)
   478: |V-----            bm_add(:) = bm_alloc(:,j,ileaf) + bm_alloc(:,j,isapabove) + &
   479: |                              bm_alloc(:,j,iroot) + bm_alloc(:,j,ifruit)
   480: |          
   481: |V----->           WHERE ( ( bm_new(:) .GT. 0.0 ) .AND. ( bm_add(:) .GT. 0.0 ) )
   482: |V-----              age(:,j) = age(:,j) * ( bm_new(:) - bm_add(:) ) / bm_new(:)
   483: |                  ENDWHERE
   484: |          
   485: |                ENDIF
   486: |          
   487: +------        ENDDO
   488:            
   489:                !
   490:                ! 10 history
   491:                !
   492:            
   493:                CALL histwrite (hist_id_stomate, 'BM_ALLOC_LEAF', itime, &
   494:                                bm_alloc(:,:,ileaf), npts*npft, horipft_index)
   495:                CALL histwrite (hist_id_stomate, 'BM_ALLOC_SAP_AB', itime, &
   496:                                bm_alloc(:,:,isapabove), npts*npft, horipft_index)
   497:                CALL histwrite (hist_id_stomate, 'BM_ALLOC_SAP_BE', itime, &
   498:                                bm_alloc(:,:,isapbelow), npts*npft, horipft_index)
   499:                CALL histwrite (hist_id_stomate, 'BM_ALLOC_ROOT', itime, &
   500:                                bm_alloc(:,:,iroot), npts*npft, horipft_index)
   501:                CALL histwrite (hist_id_stomate, 'BM_ALLOC_FRUIT', itime, &
   502:                                bm_alloc(:,:,ifruit), npts*npft, horipft_index)
   503:                CALL histwrite (hist_id_stomate, 'BM_ALLOC_RES', itime, &
   504:                                bm_alloc(:,:,icarbres), npts*npft, horipft_index)
   505:            
   506:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving npp'
   507:            
   508:              END SUBROUTINE npp_calc
   509:            
   510:            END MODULE stomate_npp
