Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:35 2008
FILE NAME: i.stomate_phenology.f90
PROGRAM NAME: stomate_phenology
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   166  vec  (   3): Unvectorized loop.
   166  vec  (  13): Overhead of loop division is too large.
   168  opt  (1592): Outer loop unrolled inside inner loop.
   168  vec  (   4): Vectorized array expression.
   182  vec  (   4): Vectorized array expression.
   189  opt  (1592): Outer loop unrolled inside inner loop.
   193  vec  (   3): Unvectorized loop.
   199  vec  (  10): Vectorization obstructive procedure reference.:pheno_hum
   206  vec  (  10): Vectorization obstructive procedure reference.:pheno_moi
   214  vec  (  10): Vectorization obstructive procedure reference.:pheno_ncdgdd
   220  vec  (  10): Vectorization obstructive procedure reference.:pheno_ngd
   225  vec  (  10): Vectorization obstructive procedure reference.:pheno_humgdd
   233  vec  (  10): Vectorization obstructive procedure reference.:pheno_moigdd
   248  vec  (   9): Vectorization obstructive statement.
   261  vec  (   4): Vectorized array expression.
   263  vec  (   1): Vectorized loop.
   338  opt  (1082): Backward transfers inhibit loop optimization.
   338  vec  (   4): Vectorized array expression.
   342  vec  (   4): Vectorized array expression.
   342  vec  (   4): Vectorized array expression.
   342  vec  (   4): Vectorized array expression.
   350  vec  (   4): Vectorized array expression.
   350  vec  (   4): Vectorized array expression.
   350  vec  (   4): Vectorized array expression.
   350  vec  (   4): Vectorized array expression.
   360  warn (  83): Dummy argument "lai" is not used.
   360  warn (  83): Dummy argument "gpp" is not used.
   360  warn (  83): Dummy argument "senescence" is not used.
   440  vec  (   4): Vectorized array expression.
   469  vec  (   1): Vectorized loop.
   572  vec  (   4): Vectorized array expression.
   601  vec  (   1): Vectorized loop.
   721  vec  (   4): Vectorized array expression.
   727  vec  (   6): Unvectorized array expression.
   727  vec  (   7): Iteration count is too small.
   759  vec  (   1): Vectorized loop.
   883  vec  (   4): Vectorized array expression.
   889  vec  (   6): Unvectorized array expression.
   889  vec  (   7): Iteration count is too small.
   921  vec  (   1): Vectorized loop.
  1009  vec  (   4): Vectorized array expression.
  1027  vec  (   1): Vectorized loop.
  1105  vec  (   4): Vectorized array expression.
  1123  vec  (   1): Vectorized loop.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:35 2008
FILE NAME: i.stomate_phenology.f90
PROGRAM NAME: stomate_phenology
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! Phenology
     2:            !
     3:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_phenology.f90,v 1.9 2007/05/28 14:49:02 ssipsl Exp $
     4:            ! IPSL (2006)
     5:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
     6:            !
     7:            MODULE stomate_phenology
     8:            
     9:              ! modules used:
    10:            
    11:              USE ioipsl
    12:              USE stomate_constants
    13:            
    14:              IMPLICIT NONE
    15:            
    16:              ! private & public routines
    17:            
    18:              PRIVATE
    19:              PUBLIC phenology,phenology_clear
    20:            
    21:               ! first call
    22:                LOGICAL, SAVE                                              :: firstcall = .TRUE.
    23:                LOGICAL, SAVE                                              :: firstcall_hum = .TRUE.
    24:                LOGICAL, SAVE                                              :: firstcall_moi = .TRUE.
    25:               LOGICAL, SAVE                                              :: firstcall_humgdd = .TRUE.
    26:               LOGICAL, SAVE                                              :: firstcall_moigdd = .TRUE.
    27:            
    28:            CONTAINS
    29:            
    30:              SUBROUTINE phenology_clear
    31:                firstcall=.TRUE.
    32:                firstcall_hum=.TRUE.
    33:                firstcall_moi = .TRUE.
    34:                firstcall_humgdd = .TRUE.
    35:                firstcall_moigdd = .TRUE.
    36:              END SUBROUTINE phenology_clear
    37:            
    38:              SUBROUTINE phenology (npts, dt, PFTpresent, &
    39:                                    veget_max, space_nat, &
    40:                                    tlong_ref, t2m_month, t2m_week, gpp, &
    41:                                    maxmoiavail_lastyear, minmoiavail_lastyear, &
    42:                                    moiavail_month, moiavail_week, &
    43:                                    gdd_m5_dormance, gdd_midwinter, ncd_dormance, ngd_minus5, &
    44:                                    senescence, time_lowgpp, time_hum_min, &
    45:                                    biomass, leaf_frac, leaf_age, &
    46:                                    when_growthinit, co2_to_bm, lai)
    47:            
    48:                !
    49:                ! 0 declarations
    50:                !
    51:            
    52:                ! 0.1 input
    53:            
    54:                ! Domain size
    55:                INTEGER(i_std), INTENT(in)                                        :: npts
    56:                ! time step in days
    57:                REAL(r_std), INTENT(in)                                     :: dt
    58:                ! PFT exists
    59:                LOGICAL, DIMENSION(npts,npft), INTENT(in)                  :: PFTpresent
    60:                ! "maximal" coverage fraction of a PFT (LAI -> infinity) on nat/agri ground
    61:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: veget_max
    62:                ! total natural space (fraction of total space)
    63:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: space_nat
    64:                ! "long term" 2 meter reference temperatures (K)
    65:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: tlong_ref
    66:                ! "monthly" 2-meter temperatures (K)
    67:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: t2m_month
    68:                ! "weekly" 2-meter temperatures (K)
    69:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: t2m_week
    70:                ! daily gross primary productivity (gC/(m**2 of nat/agri ground)/day)
    71:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: gpp
    72:                ! last year's maximum moisture availability
    73:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: maxmoiavail_lastyear
    74:                ! last year's minimum moisture availability
    75:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: minmoiavail_lastyear
    76:                ! "monthly" moisture availability
    77:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: moiavail_month
    78:                ! "weekly" moisture availability
    79:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: moiavail_week
    80:                ! growing degree days, threshold -5 deg C
    81:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: gdd_m5_dormance
    82:                ! growing degree days, since midwinter
    83:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)               :: gdd_midwinter
    84:                ! number of chilling days since leaves were lost
    85:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: ncd_dormance
    86:                ! number of growing days, threshold -5 deg C
    87:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: ngd_minus5
    88:                ! is the plant senescent? (only for deciduous trees - carbohydrate reserve)
    89:                LOGICAL, DIMENSION(npts,npft), INTENT(in)                  :: senescence
    90:                ! duration of dormance (d)
    91:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: time_lowgpp
    92:                ! time elapsed since strongest moisture availability (d)
    93:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: time_hum_min
    94:            
    95:                ! 0.2 modified fields
    96:            
    97:                ! biomass (gC/(m**2 of natural or agricultural ground))
    98:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)     :: biomass
    99:                ! fraction of leaves in leaf age class
   100:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)  :: leaf_frac
   101:                ! leaf age (days)
   102:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)  :: leaf_age
   103:                ! how many days ago was the beginning of the growing season
   104:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)            :: when_growthinit
   105:                ! co2 taken up (gC/(m**2 of total ground)/day)
   106:                REAL(r_std), DIMENSION(npts), INTENT(inout)                 :: co2_to_bm
   107:            
   108:                ! 0.3 output
   109:            
   110:                ! leaf area index
   111:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)              :: lai
   112:            
   113:                ! 0.4 local
   114:            
   115:                ! take carbon from atmosphere if carbohydrate reserve too small?
   116:                LOGICAL, PARAMETER                                         :: always_init = .FALSE.
   117:                ! minimum time (d) since last beginning of a growing season
   118:                REAL(r_std), PARAMETER                                      :: min_growthinit_time = 300.
   119:                ! are we allowed to decalre the beginning of the growing season?
   120:                LOGICAL, DIMENSION(npts,npft)                              :: allow_initpheno
   121:                ! biomass we would like to have
   122:                REAL(r_std), DIMENSION(npts)                                :: bm_wanted
   123:                ! biomass we use (from carbohydrate reserve or from atmosphere)
   124:                REAL(r_std), DIMENSION(npts)                                :: bm_use
   125:                ! minimum leaf mass (gC/(m**2 of natural or agricultural ground))
   126:                REAL(r_std), DIMENSION(npts)                                :: lm_min
   127:                ! does the leaf age distribution have to be reset?
   128:                LOGICAL(r_std), DIMENSION(npts)                             :: age_reset
   129:                ! indices
   130:                INTEGER(i_std)                                              :: i,j,m
   131:                ! signal to start putting leaves on
   132:                LOGICAL, DIMENSION(npts,npft)                              :: begin_leaves
   133:             
   134:                ! =========================================================================
   135:            
   136:                IF (bavard.GE.3) WRITE(numout,*) 'Entering phenology'
   137:            
   138:                !
   139:                ! 1 first call
   140:                !
   141:            
   142:                IF ( firstcall ) THEN
   143:            
   144:                  WRITE(numout,*) 'phenology:'
   145:            
   146:                  WRITE(numout,*) '   > take carbon from atmosphere if carbohydrate' // &
   147:                                  ' reserve too small: ', always_init
   148:            
   149:                  WRITE(numout,*) '   > minimum time since last beginning of a growing' // &
   150:                                  ' season (d): ', min_growthinit_time
   151:            
   152:                  firstcall = .FALSE.
   153:            
   154:                ENDIF
   155:            
   156:                !
   157:                ! 2 various things
   158:                !
   159:            
   160:                !
   161:                ! 2.1 allow detection of the beginning of the growing season if dormance was
   162:                !     long enough and last beginning of growing season was a sufficiently 
   163:                !     long time ago
   164:                !
   165:            
   166: +------>       DO j = 1, npft
   167: |          
   168: |V----->         WHERE ( ( time_lowgpp(:,j) .GE. pheno_crit%lowgpp_time(j) ) .AND. &
   169: ||                       ( when_growthinit(:,j) .GT. min_growthinit_time )          )
   170: ||                 allow_initpheno(:,j) = .TRUE.
   171: ||               ELSEWHERE
   172: |V-----            allow_initpheno(:,j) = .FALSE.
   173: |                ENDWHERE
   174: |          
   175: +------        ENDDO
   176:            
   177:                !
   178:                ! 2.2 increase counter: how many days ago was the beginning of the growing season
   179:                !     Needed for allocation
   180:                !
   181:            
   182: *V----->       when_growthinit(:,:) = when_growthinit(:,:) + dt
   183: ||         
   184: ||             !
   185: ||             ! 3 Check biometeorological conditions
   186: ||             !
   187: ||         
   188: ||             ! default: phenology does not start
   189: *V-----        begin_leaves(:,:) = .FALSE.
   190:            
   191:                ! different kinds of phenology
   192:            
   193: +------>       DO j = 1, npft
   194: |          
   195: |                SELECT CASE ( pheno_crit%pheno_model(j) )
   196: |          
   197: |                CASE ( 'hum' )
   198: |          
   199: |                  CALL pheno_hum (npts, j, PFTpresent, allow_initpheno, &
   200: |                                  moiavail_month, moiavail_week, &
   201: |                                  maxmoiavail_lastyear, minmoiavail_lastyear, &
   202: |                                  begin_leaves)
   203: |          
   204: |                CASE ( 'moi' )
   205: |          
   206: |                  CALL pheno_moi (npts, j, PFTpresent, allow_initpheno, &
   207: |                                  time_hum_min, &
   208: |                                  moiavail_month, moiavail_week, &
   209: |                                  begin_leaves)
   210: |          
   211: |          
   212: |                CASE ( 'ncdgdd' )
   213: |          
   214: |                  CALL pheno_ncdgdd (npts, j, PFTpresent, allow_initpheno, &
   215: |                                     ncd_dormance, gdd_midwinter, &
   216: |                                     t2m_month, t2m_week, begin_leaves)
   217: |          
   218: |                CASE ( 'ngd' )
   219: |          
   220: |                  CALL pheno_ngd (npts, j, PFTpresent, allow_initpheno, ngd_minus5, &
   221: |                                  t2m_month, t2m_week, begin_leaves)
   222: |          
   223: |                CASE ( 'humgdd' )
   224: |          
   225: |                  CALL pheno_humgdd (npts, j, PFTpresent, allow_initpheno, gdd_m5_dormance, &
   226: |                                     maxmoiavail_lastyear, minmoiavail_lastyear, &
   227: |                                     tlong_ref, t2m_month, t2m_week, &
   228: |                                     moiavail_week, moiavail_month, &
   229: |                                     begin_leaves)
   230: |          
   231: |                CASE ( 'moigdd' )
   232: |          
   233: |                  CALL pheno_moigdd (npts, j, PFTpresent, allow_initpheno, gdd_m5_dormance, &
   234: |                                     time_hum_min, &
   235: |                                     tlong_ref, t2m_month, t2m_week, &
   236: |                                     moiavail_week, moiavail_month, &
   237: |                                     begin_leaves)
   238: |          
   239: |                CASE ( 'none' )
   240: |          
   241: |                  ! no action
   242: |          
   243: |                CASE default
   244: |          
   245: |                  WRITE(numout,*) 'phenology: don''t know how to treat this PFT.'
   246: |                  WRITE(numout,*) '  number:',j
   247: |                  WRITE(numout,*) '  phenology model: ',pheno_crit%pheno_model(j)
   248: |                  STOP
   249: |          
   250: |                END SELECT
   251: |          
   252: +------        ENDDO
   253:            
   254:                !
   255:                ! 4 leaves start to grow if meteorological conditions are favourable and if
   256:                !   leaf regrowth is allowed (cf also turnover)
   257:                !
   258:            
   259: +------>       DO j = 1, npft
   260: |          
   261: |V=====          age_reset(:) = .FALSE.
   262: |          
   263: |V----->         DO i = 1, npts
   264: ||         
   265: ||                 IF ( begin_leaves(i,j) ) THEN
   266: ||         
   267: ||                   lm_min(i) = veget_max(i,j) * pheno_crit%lai_initmin(j) / sla(j)
   268: ||         
   269: ||                   ! do we have to put a minimum biomass into the leaves?
   270: ||         
   271: ||                   IF ( biomass(i,j,ileaf) .LT. lm_min(i) ) THEN
   272: ||         
   273: ||                     !
   274: ||                     ! 4.1 determine how much biomass we can use
   275: ||                     !
   276: ||         
   277: ||                     bm_wanted(i) = 2. * lm_min(i)
   278: ||         
   279: ||                     ! eventually take the missing carbon from the atmosphere and
   280: ||                     ! put it into carbohydrate reserve
   281: ||         
   282: ||                     IF ( always_init .AND. ( biomass(i,j,icarbres) .LT. bm_wanted(i) ) ) THEN
   283: ||         
   284: ||                       IF ( natural(j) ) THEN
   285: ||                         co2_to_bm(i) = co2_to_bm(i) + &
   286: ||                            ( bm_wanted(i) - biomass(i,j,icarbres) ) * space_nat(i) / dt
   287: ||                       ELSE
   288: ||                         co2_to_bm(i) = co2_to_bm(i) + &
   289: ||                            ( bm_wanted(i) - biomass(i,j,icarbres) ) * ( 1. - space_nat(i) ) / dt
   290: ||                       ENDIF
   291: ||         
   292: ||                       biomass(i,j,icarbres) = bm_wanted(i)
   293: ||         
   294: ||                     ENDIF
   295: ||         
   296: ||                     bm_use(i) = MIN( biomass(i,j,icarbres), bm_wanted(i) )
   297: ||         
   298: ||                     !
   299: ||                     ! 4.2 dispatch that biomass on leaves and roots
   300: ||                     !
   301: ||         
   302: ||                     biomass(i,j,ileaf) = biomass(i,j,ileaf) + bm_use(i) / 2.
   303: ||         
   304: ||                     biomass(i,j,iroot) = biomass(i,j,iroot) + bm_use(i) / 2.
   305: ||         
   306: ||                     !
   307: ||                     ! 4.3 decrease reservoir biomass
   308: ||                     !
   309: ||         
   310: ||                     biomass(i,j,icarbres) = biomass(i,j,icarbres) - bm_use(i)
   311: ||         
   312: ||                     !
   313: ||                     ! 4.4 decide whether we have to reset then leaf age distribution
   314: ||                     !     (done later for better vectorization)
   315: ||                     !
   316: ||         
   317: ||                     age_reset(i) = .TRUE.
   318: ||         
   319: ||                   ENDIF  ! leaf mass is very low
   320: ||         
   321: ||                   !
   322: ||                   ! 4.5 reset counter: start of the growing season
   323: ||                   !
   324: ||         
   325: ||                   when_growthinit(i,j) = 0.0
   326: ||         
   327: ||                 ENDIF    ! start of the growing season
   328: ||         
   329: |V-----          ENDDO      ! loop over grid points
   330: |          
   331: |                !
   332: |                ! 4.6 reset leaf age distribution where necessary
   333: |                !     simply say that everything is in the youngest age class
   334: |                !
   335: |          
   336: |                ! 4.6.1 fractions
   337: |          
   338: |V----->         WHERE ( age_reset(:) )
   339: |V-----            leaf_frac(:,j,1) = 1.0
   340: |                ENDWHERE
   341: |*----->         DO m = 2, nleafages
   342: ||V---->           WHERE ( age_reset(:) )
   343: ||V----              leaf_frac(:,j,m) = 0.0
   344: ||                 ENDWHERE
   345: |*-----          ENDDO
   346: |          
   347: |                ! 4.6.2 ages
   348: |          
   349: |*----->         DO m = 1, nleafages
   350: ||V---->           WHERE ( age_reset(:) )
   351: ||V----              leaf_age(:,j,m) = 0.0
   352: ||                 ENDWHERE
   353: |*-----          ENDDO
   354: |          
   355: +------        ENDDO        ! loop over PFTs
   356:            
   357:            
   358:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving phenology'
   359:            
   360:              END SUBROUTINE phenology
   361:            
   362:              !
   363:              ! ==============================================================================
   364:              ! Phenology: begins if "weekly" soil humidity starts to exceed a certain threshold
   365:              !            value. This value depends on last year's max and min humidity ...
   366:              !            Always initiate growing season if soil moisture exceeds a certain threshold.
   367:              !
   368:            
   369:              SUBROUTINE pheno_hum (npts, j, PFTpresent, allow_initpheno, &
   370:                                    moiavail_month, moiavail_week, &
   371:                                    maxmoiavail_lastyear, minmoiavail_lastyear, &
   372:                                    begin_leaves)
   373:            
   374:                !
   375:                ! 0 declarations
   376:                !
   377:            
   378:                ! 0.1 input
   379:            
   380:                ! Domain size
   381:                INTEGER(i_std), INTENT(in)                                     :: npts
   382:                ! PFT index
   383:                INTEGER(i_std), INTENT(in)                               :: j
   384:                ! PFT exists
   385:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: PFTpresent
   386:                ! are we allowed to decalre the beginning of the growing season?
   387:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: allow_initpheno
   388:                ! "monthly" moisture availability
   389:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: moiavail_month
   390:                ! "weekly" moisture availability
   391:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: moiavail_week
   392:                ! last year's maximum moisture availability
   393:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: maxmoiavail_lastyear
   394:                ! last year's minimum moisture availability
   395:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: minmoiavail_lastyear
   396:            
   397:                ! 0.2 output
   398:            
   399:                ! signal to start putting leaves on
   400:                LOGICAL, DIMENSION(npts,npft), INTENT(out)              :: begin_leaves
   401:            
   402:                ! 0.3 local
   403:            
   404:                ! moisture availability above which moisture tendency doesn't matter
   405:                REAL(r_std), PARAMETER                                   :: moiavail_always_tree = 1.0
   406:                REAL(r_std), PARAMETER                                   :: moiavail_always_grass = 0.6
   407:                REAL(r_std)                                              :: moiavail_always
   408:                ! first call
   409:                REAL(r_std), DIMENSION(npts)                             :: availability_crit
   410:                ! index
   411:                INTEGER(i_std)                                           :: i
   412:            
   413:                ! =========================================================================
   414:            
   415:                IF (bavard.GE.3) WRITE(numout,*) 'Entering hum'
   416:            
   417:                !
   418:                ! Initializations
   419:                !
   420:            
   421:                !
   422:                ! 1.1 messages
   423:                !
   424:            
   425:                IF ( firstcall_hum ) THEN
   426:            
   427:                  WRITE(numout,*) 'pheno_hum:'
   428:                  WRITE(numout,*) '   > moisture availability above which moisture tendency doesn''t matter: '
   429:                  WRITE(numout,*) '         trees:', moiavail_always_tree
   430:                  WRITE(numout,*) '         grasses:', moiavail_always_grass
   431:            
   432:                  firstcall_hum = .FALSE.
   433:            
   434:                ENDIF
   435:            
   436:                !
   437:                ! 1.2 initialize output
   438:                !
   439:            
   440: V======        begin_leaves(:,j) = .FALSE.
   441:            
   442:                !
   443:                ! 1.3 check the prescribed critical value
   444:                !
   445:            
   446:                IF ( pheno_crit%hum_frac(j) .EQ. undef ) THEN
   447:            
   448:                  WRITE(numout,*) 'hum: pheno_crit%hum_frac is undefined for PFT',j
   449:                  WRITE(numout,*) 'We stop.'
   450:                  STOP
   451:            
   452:                ENDIF
   453:            
   454:                !
   455:                ! 1.4 critical moisture availability above which we always detect the beginning of the
   456:                !     growing season.
   457:                !
   458:            
   459:                IF ( tree(j) ) THEN
   460:                  moiavail_always = moiavail_always_tree
   461:                ELSE
   462:                  moiavail_always = moiavail_always_grass
   463:                ENDIF
   464:            
   465:                !
   466:                ! 2 PFT has to be there and start of growing season must be allowed
   467:                !
   468:            
   469: V------>       DO i = 1, npts
   470: |          
   471: |                IF ( PFTpresent(i,j) .AND. allow_initpheno(i,j) ) THEN
   472: |          
   473: |                  ! critical availability: depends on last year's max and min.
   474: |          
   475: |                  availability_crit(i) = minmoiavail_lastyear(i,j) + pheno_crit%hum_frac(j) * &
   476: |                                   ( maxmoiavail_lastyear(i,j) - minmoiavail_lastyear(i,j) )
   477: |          
   478: |                  ! the favorable season starts if the "monthly" moisture availability is still quite
   479: |                  ! low, but the "weekly" availability is already higher (as it reacts faster).
   480: |                  ! If monthly moisture availability is high enough, also initiate growing season if
   481: |                  ! this has not happened yet.
   482: |          
   483: |                  IF ( ( ( moiavail_week(i,j)  .GE. availability_crit(i) ) .AND. &
   484: |                         ( moiavail_month(i,j) .LT. moiavail_week(i,j) )   ) .OR. &
   485: |                       ( moiavail_month(i,j) .GE. moiavail_always )                ) THEN
   486: |                    begin_leaves(i,j) = .TRUE.
   487: |                  ENDIF
   488: |          
   489: |                ENDIF        ! PFT there and start of growing season allowed
   490: |          
   491: V------        ENDDO
   492:            
   493:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving hum'
   494:            
   495:              END SUBROUTINE pheno_hum
   496:            
   497:              !
   498:              ! ==============================================================================
   499:              ! Phenology: begins if moisture minium was a sufficiently long time ago.
   500:              !            Additionally, "weekly" soil humidity must be higher that "monthly" soil
   501:              !            humidity.
   502:              !
   503:            
   504:              SUBROUTINE pheno_moi (npts, j, PFTpresent, allow_initpheno, &
   505:                                    time_hum_min, &
   506:                                    moiavail_month, moiavail_week, &
   507:                                    begin_leaves)
   508:            
   509:                !
   510:                ! 0 declarations
   511:                !
   512:            
   513:                ! 0.1 input
   514:            
   515:                ! Domain size
   516:                INTEGER(i_std), INTENT(in)                                     :: npts
   517:                ! PFT index
   518:                INTEGER(i_std), INTENT(in)                               :: j
   519:                ! PFT exists
   520:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: PFTpresent
   521:                ! are we allowed to decalre the beginning of the growing season?
   522:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: allow_initpheno
   523:                ! time elapsed since strongest moisture availability (d)
   524:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: time_hum_min
   525:                ! "monthly" moisture availability
   526:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: moiavail_month
   527:                ! "weekly" moisture availability
   528:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: moiavail_week
   529:            
   530:                ! 0.2 output
   531:            
   532:                ! signal to start putting leaves on
   533:                LOGICAL, DIMENSION(npts,npft), INTENT(out)              :: begin_leaves
   534:            
   535:                ! 0.3 local
   536:            
   537:                ! moisture availability above which moisture tendency doesn't matter
   538:                ! moisture availability above which moisture tendency doesn't matter
   539:                REAL(r_std), PARAMETER                                   :: moiavail_always_tree = 1.0
   540:                REAL(r_std), PARAMETER                                   :: moiavail_always_grass = 0.6
   541:                REAL(r_std)                                              :: moiavail_always
   542:                ! index
   543:                INTEGER(i_std)                                           :: i
   544:            
   545:                ! =========================================================================
   546:            
   547:                IF (bavard.GE.3) WRITE(numout,*) 'Entering moi'
   548:            
   549:                !
   550:                ! Initializations
   551:                !
   552:            
   553:                !
   554:                ! 1.1 messages
   555:                !
   556:            
   557:                IF ( firstcall_moi ) THEN
   558:            
   559:                  WRITE(numout,*) 'pheno_moi:'
   560:                  WRITE(numout,*) '   > moisture availability above which moisture tendency doesn''t matter: '
   561:                  WRITE(numout,*) '         trees:', moiavail_always_tree
   562:                  WRITE(numout,*) '         grasses:', moiavail_always_grass
   563:            
   564:                  firstcall_moi = .FALSE.
   565:            
   566:                ENDIF
   567:            
   568:                !
   569:                ! 1.2 initialize output
   570:                !
   571:            
   572: V======        begin_leaves(:,j) = .FALSE.
   573:            
   574:                !
   575:                ! 1.3 check the prescribed critical value
   576:                !
   577:            
   578:                IF ( pheno_crit%hum_min_time(j) .EQ. undef ) THEN
   579:            
   580:                  WRITE(numout,*) 'moi: pheno_crit%hum_min_time is undefined for PFT',j
   581:                  WRITE(numout,*) 'We stop.'
   582:                  STOP
   583:            
   584:                ENDIF
   585:            
   586:                !
   587:                ! 1.4 critical moisture availability above which we always detect the beginning of the
   588:                !     growing season.
   589:                !
   590:            
   591:                IF ( tree(j) ) THEN
   592:                  moiavail_always = moiavail_always_tree
   593:                ELSE
   594:                  moiavail_always = moiavail_always_grass
   595:                ENDIF
   596:            
   597:                !
   598:                ! 2 PFT has to be there and start of growing season must be allowed
   599:                !
   600:            
   601: V------>       DO i = 1, npts
   602: |          
   603: |                IF ( PFTpresent(i,j) .AND. allow_initpheno(i,j) ) THEN
   604: |          
   605: |                  ! the favorable season starts if the moisture minimum was a sufficiently long 
   606: |                  ! time ago and if the "monthly" moisture availability is lower than the "weekly"
   607: |                  ! availability (this means that soil moisture is increasing).
   608: |                  ! If monthly moisture availability is high enough, also initiate growing season if
   609: |                  ! this has not happened yet.
   610: |          
   611: |                  IF  ( ( ( moiavail_week(i,j) .GT. moiavail_month(i,j) ) .AND. &
   612: |                          ( time_hum_min(i,j) .GT. pheno_crit%hum_min_time(j) )    ) .OR. &
   613: |                        ( moiavail_month(i,j) .GE. moiavail_always )                     ) THEN
   614: |                    begin_leaves(i,j) = .TRUE.
   615: |                  ENDIF
   616: |          
   617: |                ENDIF        ! PFT there and start of growing season allowed
   618: |          
   619: V------        ENDDO
   620:            
   621:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving moi'
   622:            
   623:              END SUBROUTINE pheno_moi
   624:            
   625:              !
   626:              ! ==============================================================================
   627:              ! Phenology: leaves are put on if gdd exceeds a critical value.
   628:              !            Additionally, there has to be at least some moisture.
   629:              !            Set gdd to undef if beginning of the growing season detected.
   630:              !
   631:            
   632:              SUBROUTINE pheno_humgdd (npts, j, PFTpresent, allow_initpheno, gdd, &
   633:                                       maxmoiavail_lastyear, minmoiavail_lastyear, &
   634:                                       tlong_ref, t2m_month, t2m_week, &
   635:                                       moiavail_week, moiavail_month, &
   636:                                       begin_leaves)
   637:            
   638:                !
   639:                ! 0 declarations
   640:                !
   641:            
   642:                ! 0.1 input
   643:            
   644:                ! Domain size
   645:                INTEGER(i_std), INTENT(in)                                     :: npts
   646:                ! PFT index
   647:                INTEGER(i_std), INTENT(in)                               :: j
   648:                ! PFT exists
   649:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: PFTpresent
   650:                ! are we allowed to decalre the beginning of the growing season?
   651:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: allow_initpheno
   652:                ! growing degree days, calculated since leaves have fallen
   653:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: gdd
   654:                ! last year's maximum moisture availability
   655:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: maxmoiavail_lastyear
   656:                ! last year's minimum moisture availability
   657:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: minmoiavail_lastyear
   658:                ! "long term" 2 meter temperatures (K)
   659:                REAL(r_std), DIMENSION(npts), INTENT(in)                 :: tlong_ref
   660:                ! "monthly" 2-meter temperatures (K)
   661:                REAL(r_std), DIMENSION(npts), INTENT(in)                 :: t2m_month
   662:                ! "weekly" 2-meter temperatures (K)
   663:                REAL(r_std), DIMENSION(npts), INTENT(in)                 :: t2m_week
   664:                ! "weekly" moisture availability
   665:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: moiavail_week
   666:                ! "monthly" moisture availability
   667:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: moiavail_month
   668:            
   669:                ! 0.2 output
   670:            
   671:                ! signal to start putting leaves on
   672:                LOGICAL, DIMENSION(npts,npft), INTENT(out)              :: begin_leaves
   673:            
   674:                ! 0.3 local
   675:            
   676:                ! moisture availability above which moisture tendency doesn't matter
   677:                ! moisture availability above which moisture tendency doesn't matter
   678:                REAL(r_std), PARAMETER                                   :: moiavail_always_tree = 1.0
   679:                REAL(r_std), PARAMETER                                   :: moiavail_always_grass = 0.6
   680:                REAL(r_std)                                              :: moiavail_always
   681:                ! monthly temp. above which temp. tendency doesn't matter
   682:                REAL(r_std), PARAMETER                                   :: t_always = ZeroCelsius + 10.
   683:                ! critical moisture availability
   684:                REAL(r_std), DIMENSION(npts)                             :: moiavail_crit
   685:                ! long term temperature, C
   686:                REAL(r_std), DIMENSION(npts)                             :: tl
   687:                ! critical GDD
   688:                REAL(r_std), DIMENSION(npts)                             :: gdd_crit
   689:                ! index
   690:                INTEGER(i_std)                                           :: i
   691:            
   692:                ! =========================================================================
   693:            
   694:                IF (bavard.GE.3) WRITE(numout,*) 'Entering humgdd'
   695:            
   696:                !
   697:                ! 1 Initializations
   698:                !
   699:            
   700:                !
   701:                ! 1.1 messages
   702:                !
   703:            
   704:                IF ( firstcall_humgdd ) THEN
   705:            
   706:                  WRITE(numout,*) 'pheno_humgdd:'
   707:                  WRITE(numout,*) '   > moisture availability above which moisture tendency doesn''t matter: '
   708:                  WRITE(numout,*) '         trees:', moiavail_always_tree
   709:                  WRITE(numout,*) '         grasses:', moiavail_always_grass
   710:                  WRITE(numout,*) '   > monthly temp. above which temp. tendency doesn''t matter: ', &
   711:                                     t_always
   712:            
   713:                  firstcall_humgdd = .FALSE.
   714:            
   715:                ENDIF
   716:            
   717:                !
   718:                ! 1.2 initialize output
   719:                !
   720:            
   721: V======        begin_leaves(:,j) = .FALSE.
   722:            
   723:                !
   724:                ! 1.3 check the prescribed critical values
   725:                !
   726:            
   727: *======        IF ( ANY(pheno_crit%gdd(j,:) .EQ. undef) ) THEN
   728:            
   729:                  WRITE(numout,*) 'humgdd: pheno_crit%gdd is undefined for PFT',j
   730:                  WRITE(numout,*) 'We stop.'
   731:                  STOP
   732:            
   733:                ENDIF
   734:            
   735:                IF ( pheno_crit%hum_frac(j) .EQ. undef ) THEN
   736:            
   737:                  WRITE(numout,*) 'humgdd: pheno_crit%hum_frac is undefined for PFT',j
   738:                  WRITE(numout,*) 'We stop.'
   739:                  STOP
   740:            
   741:                ENDIF
   742:            
   743:                !
   744:                ! 1.4 critical moisture availability above which we always detect the beginning of the
   745:                !     growing season.
   746:                !
   747:            
   748:                IF ( tree(j) ) THEN
   749:                  moiavail_always = moiavail_always_tree
   750:                ELSE
   751:                  moiavail_always = moiavail_always_grass
   752:                ENDIF
   753:            
   754:                !
   755:                ! 2 PFT has to be there, start of growing season must be allowed, 
   756:                !   and gdd has to be defined
   757:                !
   758:            
   759: V------>       DO i = 1, npts
   760: |          
   761: |                IF ( PFTpresent(i,j) .AND. allow_initpheno(i,j) .AND. &
   762: |                     ( gdd(i,j) .NE. undef )                           ) THEN
   763: |          
   764: |                  ! is critical gdd reached and is temperature increasing?
   765: |                  ! be sure that at least some humidity
   766: |          
   767: |                  moiavail_crit(i) = minmoiavail_lastyear(i,j) + pheno_crit%hum_frac(j) * &
   768: |                                      ( maxmoiavail_lastyear(i,j) - minmoiavail_lastyear(i,j) )
   769: |          
   770: |                  tl(i) = tlong_ref(i) - ZeroCelsius
   771: |                  gdd_crit(i) = pheno_crit%gdd(j,1) + tl(i)*pheno_crit%gdd(j,2) + &
   772: |                                tl(i)*tl(i)*pheno_crit%gdd(j,3)
   773: |          
   774: |                  IF ( ( gdd(i,j) .GE. gdd_crit(i) ) .AND. &
   775: |                       ( ( t2m_week(i) .GT. t2m_month(i) ) .OR. &
   776: |                         ( t2m_month(i) .GT. t_always )          ) .AND. &
   777: |                       ( ( ( moiavail_week(i,j)  .GE. moiavail_crit(i) ) .AND. &
   778: |                           ( moiavail_month(i,j) .LT. moiavail_crit(i) )        ) .OR. &
   779: |                         ( moiavail_month(i,j) .GE. moiavail_always )                   ) )  THEN
   780: |                    begin_leaves(i,j) = .TRUE.
   781: |                  ENDIF
   782: |          
   783: |                ENDIF        ! PFT there and start of growing season allowed
   784: |          
   785: V------        ENDDO
   786:            
   787:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving humgdd'
   788:            
   789:              END SUBROUTINE pheno_humgdd
   790:            
   791:              !
   792:              ! ==============================================================================
   793:              ! Phenology: leaves are put on if gdd exceeds a critical value.
   794:              !            Additionally, a certain time must have elapsed since the moisture minimum.
   795:              !            Set gdd to undef if beginning of the growing season detected.
   796:              !
   797:            
   798:              SUBROUTINE pheno_moigdd (npts, j, PFTpresent, allow_initpheno, gdd, &
   799:                                       time_hum_min, &
   800:                                       tlong_ref, t2m_month, t2m_week, &
   801:                                       moiavail_week, moiavail_month, &
   802:                                       begin_leaves)
   803:            
   804:                !
   805:                ! 0 declarations
   806:                !
   807:            
   808:                ! 0.1 input
   809:            
   810:                ! Domain size
   811:                INTEGER(i_std), INTENT(in)                                     :: npts
   812:                ! PFT index
   813:                INTEGER(i_std), INTENT(in)                               :: j
   814:                ! PFT exists
   815:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: PFTpresent
   816:                ! are we allowed to decalre the beginning of the growing season?
   817:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: allow_initpheno
   818:                ! growing degree days, calculated since leaves have fallen
   819:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: gdd
   820:                ! time elapsed since strongest moisture availability (d)
   821:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: time_hum_min
   822:                ! "long term" 2 meter temperatures (K)
   823:                REAL(r_std), DIMENSION(npts), INTENT(in)                 :: tlong_ref
   824:                ! "monthly" 2-meter temperatures (K)
   825:                REAL(r_std), DIMENSION(npts), INTENT(in)                 :: t2m_month
   826:                ! "weekly" 2-meter temperatures (K)
   827:                REAL(r_std), DIMENSION(npts), INTENT(in)                 :: t2m_week
   828:                ! "weekly" moisture availability
   829:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: moiavail_week
   830:                ! "monthly" moisture availability
   831:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: moiavail_month
   832:            
   833:                ! 0.2 output
   834:            
   835:                ! signal to start putting leaves on
   836:                LOGICAL, DIMENSION(npts,npft), INTENT(out)              :: begin_leaves
   837:            
   838:                ! 0.3 local
   839:            
   840:                ! moisture availability above which moisture tendency doesn't matter
   841:                ! moisture availability above which moisture tendency doesn't matter
   842:                REAL(r_std), PARAMETER                                   :: moiavail_always_tree = 1.0
   843:                REAL(r_std), PARAMETER                                   :: moiavail_always_grass = 0.6
   844:                REAL(r_std)                                              :: moiavail_always
   845:                ! monthly temp. above which temp. tendency doesn't matter
   846:                REAL(r_std), PARAMETER                                   :: t_always = ZeroCelsius + 10.
   847:                ! long term temperature, C
   848:                REAL(r_std), DIMENSION(npts)                             :: tl
   849:                ! critical GDD
   850:                REAL(r_std), DIMENSION(npts)                             :: gdd_crit
   851:                ! index
   852:                INTEGER(i_std)                                           :: i
   853:            
   854:                ! =========================================================================
   855:            
   856:                IF (bavard.GE.3) WRITE(numout,*) 'Entering moigdd'
   857:            
   858:                !
   859:                ! 1 Initializations
   860:                !
   861:            
   862:                !
   863:                ! 1.1 messages
   864:                !
   865:            
   866:                IF ( firstcall_moigdd ) THEN
   867:            
   868:                  WRITE(numout,*) 'pheno_moigdd:'
   869:                  WRITE(numout,*) '   > moisture availability above which moisture tendency doesn''t matter: '
   870:                  WRITE(numout,*) '         trees:', moiavail_always_tree
   871:                  WRITE(numout,*) '         grasses:', moiavail_always_grass
   872:                  WRITE(numout,*) '   > monthly temp. above which temp. tendency doesn''t matter: ', &
   873:                                     t_always
   874:            
   875:                  firstcall_moigdd = .FALSE.
   876:            
   877:                ENDIF
   878:            
   879:                !
   880:                ! 1.2 initialize output
   881:                !
   882:            
   883: V======        begin_leaves(:,j) = .FALSE.
   884:            
   885:                !
   886:                ! 1.3 check the prescribed critical values
   887:                !
   888:            
   889: *======        IF ( ANY(pheno_crit%gdd(j,:) .EQ. undef) ) THEN
   890:            
   891:                  WRITE(numout,*) 'moigdd: pheno_crit%gdd is undefined for PFT',j
   892:                  WRITE(numout,*) 'We stop.'
   893:                  STOP
   894:            
   895:                ENDIF
   896:            
   897:                IF ( pheno_crit%hum_min_time(j) .EQ. undef ) THEN
   898:            
   899:                  WRITE(numout,*) 'moigdd: pheno_crit%hum_min_time is undefined for PFT',j
   900:                  WRITE(numout,*) 'We stop.'
   901:                  STOP
   902:            
   903:                ENDIF
   904:            
   905:                !
   906:                ! 1.4 critical moisture availability above which we always detect the beginning of the
   907:                !     growing season.
   908:                !
   909:            
   910:                IF ( tree(j) ) THEN
   911:                  moiavail_always = moiavail_always_tree
   912:                ELSE
   913:                  moiavail_always = moiavail_always_grass
   914:                ENDIF
   915:            
   916:                !
   917:                ! 2 PFT has to be there, start of growing season must be allowed, 
   918:                !   and gdd has to be defined
   919:                !
   920:            
   921: V------>       DO i = 1, npts
   922: |          
   923: |                IF ( PFTpresent(i,j) .AND. allow_initpheno(i,j) .AND. &
   924: |                     ( gdd(i,j) .NE. undef )                           ) THEN
   925: |          
   926: |                  ! is critical gdd reached and is temperature increasing?
   927: |                  ! has enough time gone by since moisture minimum and is moisture increasing?
   928: |          
   929: |                  tl(i) = tlong_ref(i) - ZeroCelsius
   930: |                  gdd_crit(i) = pheno_crit%gdd(j,1) + tl(i)*pheno_crit%gdd(j,2) + &
   931: |                                tl(i)*tl(i)*pheno_crit%gdd(j,3)
   932: |          
   933: |                  IF ( ( gdd(i,j) .GE. gdd_crit(i) ) .AND. &
   934: |                       ( ( t2m_week(i) .GT. t2m_month(i) ) .OR. &
   935: |                         ( t2m_month(i) .GT. t_always )          ) .AND. &
   936: |                       ( ( ( time_hum_min(i,j) .GT. pheno_crit%hum_min_time(j) ) .AND. &
   937: |                           ( moiavail_week(i,j) .GT. moiavail_month(i,j) )            ) .OR. &
   938: |                         ( moiavail_month(i,j) .GE. moiavail_always )                         ) )  THEN
   939: |                    begin_leaves(i,j) = .TRUE.
   940: |                  ENDIF
   941: |          
   942: |                ENDIF        ! PFT there and start of growing season allowed
   943: |          
   944: V------        ENDDO
   945:            
   946:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving moigdd'
   947:            
   948:              END SUBROUTINE pheno_moigdd
   949:            
   950:            
   951:              !
   952:              ! ==============================================================================
   953:              ! Phenology: leaves are put on if a certain relationship between ncd since leaves were 
   954:              !            lost (number of chilling days) and gdd since midwinter (growing degree 
   955:              !            days) is fulfilled
   956:              !
   957:            
   958:              SUBROUTINE pheno_ncdgdd (npts, j, PFTpresent, allow_initpheno, &
   959:                                       ncd_dormance, gdd_midwinter, &
   960:                                       t2m_month, t2m_week, begin_leaves)
   961:            
   962:                !
   963:                ! 0 declarations
   964:                !
   965:            
   966:                ! 0.1 input
   967:            
   968:                ! Domain size
   969:                INTEGER(i_std), INTENT(in)                                     :: npts
   970:                ! PFT index
   971:                INTEGER(i_std), INTENT(in)                               :: j
   972:                ! PFT exists
   973:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: PFTpresent
   974:                ! are we allowed to decalre the beginning of the growing season?
   975:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: allow_initpheno
   976:                ! number of chilling days since leaves were lost
   977:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: ncd_dormance
   978:                ! growing degree days since midwinter
   979:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)            :: gdd_midwinter
   980:                ! "monthly" 2-meter temperatures (K)
   981:                REAL(r_std), DIMENSION(npts), INTENT(in)                 :: t2m_month
   982:                ! "weekly" 2-meter temperatures (K)
   983:                REAL(r_std), DIMENSION(npts), INTENT(in)                 :: t2m_week
   984:            
   985:                ! 0.2 output
   986:            
   987:                ! signal to start putting leaves on
   988:                LOGICAL, DIMENSION(npts,npft), INTENT(out)              :: begin_leaves
   989:            
   990:                ! 0.3 local
   991:            
   992:                ! index
   993:                INTEGER(i_std)                                           :: i
   994:                ! critical gdd
   995:                REAL(r_std)                                              :: gdd_min
   996:            
   997:                ! =========================================================================
   998:            
   999:                IF (bavard.GE.3) WRITE(numout,*) 'Entering ncdgdd'
  1000:            
  1001:                !
  1002:                ! 1 Initializations
  1003:                !
  1004:            
  1005:                !
  1006:                ! 1.1 initialize output
  1007:                !
  1008:            
  1009: V======        begin_leaves(:,j) = .FALSE.
  1010:            
  1011:                !
  1012:                ! 1.2 check the prescribed critical values
  1013:                !
  1014:            
  1015:                IF ( pheno_crit%ncdgdd_temp(j) .EQ. undef ) THEN
  1016:            
  1017:                  WRITE(numout,*) 'ncdgdd: pheno_crit%ncdgdd_temp is undefined for PFT',j
  1018:                  WRITE(numout,*) 'We stop.'
  1019:                  STOP
  1020:            
  1021:                ENDIF
  1022:            
  1023:                !
  1024:                ! 2 PFT has to be there and start of growing season must be allowed
  1025:                !
  1026:            
  1027: V------>       DO i = 1, npts
  1028: |          
  1029: |                IF ( PFTpresent(i,j) .AND. allow_initpheno(i,j) .AND. &
  1030: |                     ( gdd_midwinter(i,j) .NE. undef ) .AND. &
  1031: |                     ( ncd_dormance(i,j) .NE. undef )                  ) THEN
  1032: |          
  1033: |                  ! critical gdd
  1034: |          
  1035: |                  gdd_min = ( 603. / exp(0.0091*ncd_dormance(i,j)) - 64. )
  1036: |          
  1037: |                  ! has the critical gdd been reached and are temperatures increasing?
  1038: |          
  1039: |                  IF ( ( gdd_midwinter(i,j) .GE. gdd_min ) .AND. &
  1040: |                       ( t2m_week(i) .GT. t2m_month(i) ) ) THEN
  1041: |                    begin_leaves(i,j) = .TRUE.
  1042: |                    gdd_midwinter(i,j)=undef
  1043: |                  ENDIF
  1044: |          
  1045: |                ENDIF        ! PFT there and start of growing season allowed
  1046: |          
  1047: V------        ENDDO
  1048:            
  1049:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving ncdgdd'
  1050:            
  1051:              END SUBROUTINE pheno_ncdgdd
  1052:            
  1053:              !
  1054:              ! ==============================================================================
  1055:              ! Phenology: leaves are put on if ngd (number of growing days, defined as
  1056:              !            days with t>-5 deg C) exceeds a critical value.
  1057:              !
  1058:            
  1059:              SUBROUTINE pheno_ngd (npts, j, PFTpresent, allow_initpheno, ngd, &
  1060:                                    t2m_month, t2m_week, begin_leaves)
  1061:            
  1062:                !
  1063:                ! 0 declarations
  1064:                !
  1065:            
  1066:                ! 0.1 input
  1067:            
  1068:                ! Domain size
  1069:                INTEGER(i_std), INTENT(in)                                     :: npts
  1070:                ! PFT index
  1071:                INTEGER(i_std), INTENT(in)                               :: j
  1072:                ! PFT exists
  1073:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: PFTpresent
  1074:                ! are we allowed to decalre the beginning of the growing season?
  1075:                LOGICAL, DIMENSION(npts,npft), INTENT(in)               :: allow_initpheno
  1076:                ! growing degree days
  1077:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: ngd
  1078:                ! "monthly" 2-meter temperatures (K)
  1079:                REAL(r_std), DIMENSION(npts), INTENT(in)                 :: t2m_month
  1080:                ! "weekly" 2-meter temperatures (K)
  1081:                REAL(r_std), DIMENSION(npts), INTENT(in)                 :: t2m_week
  1082:            
  1083:                ! 0.2 output
  1084:            
  1085:                ! signal to start putting leaves on
  1086:                LOGICAL, DIMENSION(npts,npft), INTENT(out)              :: begin_leaves
  1087:            
  1088:                ! 0.3 local
  1089:            
  1090:                ! index
  1091:                INTEGER(i_std)                                           :: i
  1092:            
  1093:                ! =========================================================================
  1094:            
  1095:                IF (bavard.GE.3) WRITE(numout,*) 'Entering ngd'
  1096:            
  1097:                !
  1098:                ! Initializations
  1099:                !
  1100:            
  1101:                !
  1102:                ! 1.1 initialize output
  1103:                !
  1104:            
  1105: V======        begin_leaves(:,j) = .FALSE.
  1106:            
  1107:                !
  1108:                ! 1.2 check the prescribed critical value
  1109:                !
  1110:            
  1111:                IF ( pheno_crit%ngd(j) .EQ. undef ) THEN
  1112:            
  1113:                  WRITE(numout,*) 'ngd: pheno_crit%ngd is undefined for PFT',j
  1114:                  WRITE(numout,*) 'We stop.'
  1115:                  STOP
  1116:            
  1117:                ENDIF
  1118:            
  1119:                !
  1120:                ! 2 PFT has to be there and start of growing season must be allowed
  1121:                !
  1122:            
  1123: V------>       DO i = 1, npts
  1124: |          
  1125: |                IF ( PFTpresent(i,j) .AND. allow_initpheno(i,j) ) THEN
  1126: |          
  1127: |                  ! is critical ngd reached and are temperatures increasing?
  1128: |          
  1129: |                  IF ( ( ngd(i,j) .GE. pheno_crit%ngd(j) ) .AND. &
  1130: |                       ( t2m_week(i) .GT. t2m_month(i) )        ) THEN
  1131: |                    begin_leaves(i,j) = .TRUE.
  1132: |                  ENDIF
  1133: |          
  1134: |                ENDIF        ! PFT there and start of growing season allowed
  1135: |          
  1136: V------        ENDDO
  1137:            
  1138:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving ngd'
  1139:            
  1140:              END SUBROUTINE pheno_ngd
  1141:            
  1142:            END MODULE stomate_phenology
