Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:41 2008
FILE NAME: i.stomate_turnover.f90
PROGRAM NAME: stomate_turnover
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   155  opt  (1593): Loop nest collapsed into one loop.
   155  vec  (   4): Vectorized array expression.
   156  vec  (   4): Vectorized array expression.
   164  opt  (1592): Outer loop unrolled inside inner loop.
   167  opt  (1592): Outer loop unrolled inside inner loop.
   167  vec  (   4): Vectorized array expression.
   167  vec  (   4): Vectorized array expression.
   167  vec  (   4): Vectorized array expression.
   167  vec  (   4): Vectorized array expression.
   175  vec  (   3): Unvectorized loop.
   189  vec  (   4): Vectorized array expression.
   194  vec  (   4): Vectorized array expression.
   207  vec  (   4): Vectorized array expression.
   213  vec  (   4): Vectorized array expression.
   226  vec  (   4): Vectorized array expression.
   238  vec  (   4): Vectorized array expression.
   245  vec  (   4): Vectorized array expression.
   246  vec  (   4): Vectorized array expression.
   259  vec  (   4): Vectorized array expression.
   262  vec  (   4): Vectorized array expression.
   269  vec  (   4): Vectorized array expression.
   294  vec  (   4): Vectorized array expression.
   307  vec  (   4): Vectorized array expression.
   318  vec  (   4): Vectorized array expression.
   339  vec  (   4): Vectorized array expression.
   342  vec  (   4): Vectorized array expression.
   342  vec  (   4): Vectorized array expression.
   342  vec  (   4): Vectorized array expression.
   342  vec  (   4): Vectorized array expression.
   353  vec  (   4): Vectorized array expression.
   357  vec  (   3): Unvectorized loop.
   358  vec  (   4): Vectorized array expression.
   359  vec  (   4): Vectorized array expression.
   361  opt  (1059): Unable to determine last value of scalar temporary.
   394  vec  (   4): Vectorized array expression.
   402  vec  (   3): Unvectorized loop.
   404  vec  (   4): Vectorized array expression.
   406  opt  (1059): Unable to determine last value of scalar temporary.
   445  vec  (   4): Vectorized array expression.
   448  opt  (1592): Outer loop unrolled inside inner loop.
   476  vec  (   3): Unvectorized loop.
   476  vec  (  13): Overhead of loop division is too large.
   478  opt  (1033): Potential multiple store conflict -- use directive if OK.
   478  vec  (   4): Vectorized array expression.
   484  vec  (  18): Unvectorizable data type.
   488  vec  (   4): Vectorized array expression.
   491  opt  (1036): Potential feedback - use directive if OK.
   518  vec  (   4): Vectorized array expression.
   548  vec  (   4): Vectorized array expression.
   548  vec  (   4): Vectorized array expression.
   548  vec  (   4): Vectorized array expression.
   548  vec  (   4): Vectorized array expression.
   569  vec  (   3): Unvectorized loop.
   575  vec  (   4): Vectorized array expression.
   591  opt  (1097): This statement prevents loop optimization.
   591  vec  (   4): Vectorized array expression.
   593  vec  (   4): Vectorized array expression.
   621  vec  (   3): Unvectorized loop.
   621  vec  (  13): Overhead of loop division is too large.
   625  vec  (   4): Vectorized array expression.
   640  vec  (   3): Unvectorized loop.
   640  vec  (  13): Overhead of loop division is too large.
   647  vec  (   4): Vectorized array expression.
   656  vec  (   4): Vectorized array expression.
   676  vec  (   4): Vectorized array expression.
   678  opt  (1082): Backward transfers inhibit loop optimization.
   678  vec  (   4): Vectorized array expression.
   701  warn (  83): Dummy argument "lai" is not used.
   701  warn (  83): Dummy argument "pftpresent" is not used.
Linux  R2.6.5-7.283-default FORTRAN90/SX         Rev.360        Wed Oct 22 11:36:41 2008
FILE NAME: i.stomate_turnover.f90
PROGRAM NAME: stomate_turnover
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            ! This subroutine calculates:
     2:            ! 1-6 : leaf senescence, climatic and as a function of leaf age. New LAI.
     3:            ! 7 : herbivores
     4:            ! 8 : fruit turnover for trees.
     5:            ! 9 : sapwood conversion.
     6:            !
     7:            ! $Header: /home/ssipsl/CVSREP/ORCHIDEE/src_stomate/stomate_turnover.f90,v 1.11 2007/05/28 14:44:55 ssipsl Exp $
     8:            ! IPSL (2006)
     9:            !  This software is governed by the CeCILL licence see ORCHIDEE/ORCHIDEE_CeCILL.LIC
    10:            !
    11:            MODULE stomate_turnover
    12:            
    13:              ! modules used:
    14:            
    15:              USE ioipsl
    16:              USE stomate_constants
    17:            
    18:              IMPLICIT NONE
    19:            
    20:              ! private & public routines
    21:            
    22:              PRIVATE
    23:              PUBLIC turn, turn_clear
    24:            
    25:              ! first call
    26:              LOGICAL, SAVE                                              :: firstcall = .TRUE.
    27:            
    28:            CONTAINS
    29:            
    30:              SUBROUTINE turn_clear
    31:                firstcall=.TRUE.
    32:              END SUBROUTINE turn_clear
    33:            
    34:              SUBROUTINE turn (npts, dt, PFTpresent, &
    35:                               herbivores, &
    36:                               maxmoiavail_lastyear, minmoiavail_lastyear, &
    37:                               moiavail_week, moiavail_month, tlong_ref, t2m_month, t2m_week, veget_max, &
    38:                               leaf_age, leaf_frac, age, lai, biomass, &
    39:                               turnover, senescence,turnover_time)
    40:            
    41:                !
    42:                ! 0 declarations
    43:                !
    44:            
    45:                ! 0.1 input
    46:            
    47:                ! Domain size
    48:                INTEGER(i_std), INTENT(in)                                        :: npts
    49:                ! time step in days
    50:                REAL(r_std), INTENT(in)                                     :: dt
    51:                ! PFT exists
    52:                LOGICAL, DIMENSION(npts,npft), INTENT(in)                  :: PFTpresent
    53:                ! time constant of probability of a leaf to be eaten by a herbivore (days)
    54:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: herbivores
    55:                ! last year's maximum moisture availability
    56:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: maxmoiavail_lastyear
    57:                ! last year's minimum moisture availability
    58:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: minmoiavail_lastyear
    59:                ! "weekly" moisture availability
    60:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: moiavail_week
    61:                ! "monthly" moisture availability
    62:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: moiavail_month
    63:                ! "long term" 2 meter reference temperatures (K)
    64:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: tlong_ref
    65:                ! "monthly" 2-meter temperatures (K)
    66:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: t2m_month
    67:                ! "weekly" 2 meter temperatures (K)
    68:                REAL(r_std), DIMENSION(npts), INTENT(in)                    :: t2m_week
    69:                ! "maximal" coverage fraction of a PFT (LAI -> infinity) on nat/agri ground
    70:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)               :: veget_max
    71:            
    72:                ! 0.2 modified fields
    73:            
    74:                ! age of the leaves (days)
    75:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)  :: leaf_age
    76:                ! fraction of leaves in leaf age class 
    77:                REAL(r_std), DIMENSION(npts,npft,nleafages), INTENT(inout)  :: leaf_frac
    78:                ! age (years)
    79:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)            :: age
    80:                ! leaf area index
    81:                REAL(r_std), DIMENSION(npts,npft), INTENT(in)            :: lai
    82:                ! biomass (gC/(m**2 of nat/agri ground))
    83:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(inout)     :: biomass
    84:               ! turnover_time  of grasse
    85:                REAL(r_std), DIMENSION(npts,npft), INTENT(inout)            :: turnover_time
    86:            
    87:                ! 0.3 output
    88:            
    89:                ! Turnover rates (gC/day/(m**2 of nat/agri ground))
    90:                REAL(r_std), DIMENSION(npts,npft,nparts), INTENT(out)       :: turnover
    91:                ! is the plant senescent?
    92:                !   (interesting only for deciduous trees: carbohydrate reserve)
    93:                LOGICAL, DIMENSION(npts,npft), INTENT(out)                 :: senescence
    94:            
    95:                ! 0.4 local
    96:            
    97:                ! mean age of the leaves (days)
    98:                REAL(r_std), DIMENSION(npts,npft)                           :: leaf_meanage
    99:                ! Intermediate variable for turnover
   100:                REAL(r_std), DIMENSION(npts)                                :: dturnover
   101:                ! critical moisture availability, function of last year's moisture availability
   102:                REAL(r_std), DIMENSION(npts)                                :: moiavail_crit
   103:                ! long term annual mean temperature, C
   104:                REAL(r_std), DIMENSION(npts)                                :: tl
   105:                ! critical senescence temperature, function of long term annual temperature (K)
   106:                REAL(r_std), DIMENSION(npts)                                :: t_crit
   107:                ! shed the remaining leaves?
   108:                LOGICAL, DIMENSION(npts)                                   :: shed_rest
   109:                ! Sapwood conversion (gC/day(m**2 of nat/agri ground))
   110:                REAL(r_std), DIMENSION(npts)                                :: sapconv
   111:                ! old heartwood mass (gC/(m**2 of nat/agri ground))
   112:                REAL(r_std), DIMENSION(npts)                                :: hw_old
   113:                ! new heartwood mass (gC/(m**2 of nat/agri ground))
   114:                REAL(r_std), DIMENSION(npts)                                :: hw_new
   115:                ! old leaf mass (gC/(m**2 of nat/agri ground))
   116:                REAL(r_std), DIMENSION(npts)                                :: lm_old
   117:                ! leaf mass change for each age class
   118:                REAL(r_std), DIMENSION(npts,nleafages)                      :: delta_lm
   119:                ! turnover rate
   120:                REAL(r_std), DIMENSION(npts)                                :: turnover_rate
   121:                ! critical leaf age (d)
   122:                REAL(r_std), DIMENSION(npts,npft)                           :: leaf_age_crit
   123:                ! instantaneous turnover time
   124:                REAL(r_std), DIMENSION(npts,npft)                           :: new_turnover_time
   125:                ! Index
   126:                INTEGER(i_std)                                             :: j,m
   127:            
   128:                ! =========================================================================
   129:            
   130:                IF (bavard.GE.3) WRITE(numout,*) 'Entering turnover'
   131:            
   132:                !
   133:                ! 1 messages
   134:                !
   135:            
   136:                IF ( firstcall ) THEN
   137:            
   138:                  WRITE(numout,*) 'turnover:'
   139:            
   140:                  WRITE(numout,*) ' > minimum mean leaf age for senescence (d): ',pheno_crit%min_leaf_age_for_senescence
   141:            
   142:                  firstcall = .FALSE.
   143:            
   144:            
   145:                ENDIF
   146:            
   147:                !
   148:                ! 2 Initializations 
   149:                !
   150:            
   151:                !
   152:                ! 2.1 set output to zero
   153:                !
   154:            
   155: W**====        turnover(:,:,:) = 0.0
   156: *V----->       new_turnover_time=0.0
   157: ||             senescence(:,:) = .FALSE.
   158: ||         
   159: ||             !
   160: ||             ! 2.2 mean leaf age. Should actually be recalculated at the end of this routine,
   161: ||             !     but it does not change too fast.
   162: ||             !
   163: ||         
   164: *V-----        leaf_meanage(:,:) = 0.0
   165:            
   166: +------>       DO m = 1, nleafages
   167: |+V====          leaf_meanage(:,:) = leaf_meanage(:,:) + leaf_age(:,:,m) * leaf_frac(:,:,m)
   168: +------        ENDDO
   169:            
   170:                !
   171:                ! 3 different types of "climatic" leaf senescence
   172:                !   does not change age structure. 
   173:                !
   174:            
   175: +------>       DO j = 1, npft
   176: |          
   177: |                !
   178: |                ! 3.1 determine if there is climatic senescence
   179: |                !
   180: |          
   181: |                SELECT CASE ( pheno_crit%senescence_type(j) )
   182: |          
   183: |                CASE ( 'cold' )
   184: |          
   185: |                  ! 3.1.1 summergreen species:
   186: |                  !       monthly temperature low and temperature tendency negative ?
   187: |          
   188: |                  ! critical temperature for senescence may depend on long term annual mean temperature
   189: |V----->           tl(:) = tlong_ref(:) - ZeroCelsius
   190: |V-----            t_crit(:) = ZeroCelsius + pheno_crit%senescence_temp(j,1) + &
   191: |                              tl(:) * pheno_crit%senescence_temp(j,2) + &
   192: |                              tl(:)*tl(:) * pheno_crit%senescence_temp(j,3)
   193: |          
   194: |V----->           WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. &
   195: ||                         ( leaf_meanage(:,j) .GT. pheno_crit%min_leaf_age_for_senescence(j) ) .AND. &
   196: ||                         ( t2m_month(:) .LT. t_crit(:) ) .AND. ( t2m_week(:) .LT. t2m_month(:) ) )
   197: ||         
   198: |V-----              senescence(:,j) = .TRUE.
   199: |          
   200: |                  ENDWHERE
   201: |          
   202: |                CASE ( 'dry' )
   203: |          
   204: |                  ! 3.1.2 raingreen species:
   205: |                  !       does moisture availability drop below critical level?
   206: |          
   207: |V=====            moiavail_crit(:) = &
   208: |                     MIN( MAX( minmoiavail_lastyear(:,j) + pheno_crit%hum_frac(j) * &
   209: |                                   ( maxmoiavail_lastyear(:,j) - minmoiavail_lastyear(:,j) ), &
   210: |                                   pheno_crit%senescence_hum(j) ), &
   211: |                                   pheno_crit%nosenescence_hum(j) )
   212: |          
   213: |V----->           WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. &
   214: ||                         ( leaf_meanage(:,j) .GT. pheno_crit%min_leaf_age_for_senescence(j) ) .AND. &
   215: ||                         ( moiavail_week(:,j) .LT. moiavail_crit(:) ) )
   216: ||         
   217: |V-----              senescence(:,j) = .TRUE.
   218: |          
   219: |                  ENDWHERE
   220: |          
   221: |                CASE ( 'mixed' )
   222: |          
   223: |                  ! 3.1.3 mixed criterion:
   224: |                  !       moisture availability drops below critical level, or
   225: |                  !       monthly temperature low and temperature tendency negative
   226: |V----->               moiavail_crit(:) = &
   227: ||                          MIN( MAX( minmoiavail_lastyear(:,j) + pheno_crit%hum_frac(j) * &
   228: ||                          ( maxmoiavail_lastyear(:,j) - minmoiavail_lastyear(:,j) ), &
   229: ||                          pheno_crit%senescence_hum(j) ), &
   230: ||                          pheno_crit%nosenescence_hum(j) )
   231: ||                      tl(:) = tlong_ref(:) - ZeroCelsius
   232: |V-----                t_crit(:) = ZeroCelsius + pheno_crit%senescence_temp(j,1) + &
   233: |                           tl(:) * pheno_crit%senescence_temp(j,2) + &
   234: |                           tl(:)*tl(:) * pheno_crit%senescence_temp(j,3)
   235: |                   IF ( tree(j) ) THEN
   236: |                                                 
   237: |                      ! critical temperature for senescence may depend on long term annual mean temperature
   238: |V----->               WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. &
   239: ||                          ( leaf_meanage(:,j) .GT. pheno_crit%min_leaf_age_for_senescence(j) ) .AND. &
   240: ||                          ( ( moiavail_week(:,j) .LT. moiavail_crit(:) ) .OR. &
   241: ||                          ( ( t2m_month(:) .LT. t_crit(:) ) .AND. ( t2m_week(:) .LT. t2m_month(:) ) ) ) )
   242: |V-----                  senescence(:,j) = .TRUE.
   243: |                      ENDWHERE
   244: |                   ELSE
   245: |V=====                new_turnover_time(:,j)=pheno_crit%max_turnover_time(j)+20
   246: |V----->               WHERE ((moiavail_week(:,j) .LT. moiavail_month(:,j))&
   247: ||                          .AND. (moiavail_week(:,j) .LT. pheno_crit%nosenescence_hum(j)))
   248: |V-----                  new_turnover_time(:,j)=pheno_crit%max_turnover_time(j) * &
   249: |                             & moiavail_week(:,j)/ pheno_crit%nosenescence_hum(j) + &
   250: |                             & pheno_crit%min_turnover_time(j)
   251: |                      ENDWHERE
   252: |          !         WHERE ((t2m_month(:) .LT. t_crit(:)+5) .AND. ( t2m_week(:) .LT. t2m_month(:) ))
   253: |          !            new_turnover_time(:,j)=new_turnover_time(:,j)*((t2m_month(:)-t_crit(:))/5*0.4+0.6)
   254: |          !         ENDWHERE
   255: |          !         WHERE (new_turnover_time(:,j) .LT.  pheno_crit%min_turnover_time(j))
   256: |          !            new_turnover_time(:,j)=pheno_crit%min_turnover_time(j)
   257: |          !         ENDWHERE
   258: |           
   259: |V----->               WHERE (new_turnover_time(:,j) .GT. turnover_time(:,j)*1.1)
   260: |V-----                  new_turnover_time(:,j)=pheno_crit%max_turnover_time(j)+20
   261: |                      ENDWHERE
   262: |V----->               WHERE  ( ( t2m_month(:) .LT. t_crit(:) ) .AND. ( t2m_week(:) .LT. t2m_month(:) ) &
   263: ||                          &   .AND. ( leaf_meanage(:,j) .GT. pheno_crit%min_leaf_age_for_senescence(j) )) 
   264: |V-----                  new_turnover_time(:,j)=pheno_crit%min_turnover_time(j)
   265: |                      ENDWHERE
   266: |          !           print *,'t_crit=',t_crit
   267: |          
   268: |          
   269: |V=====                turnover_time(:,j)=(turnover_time(:,j)*10./dt+new_turnover_time(:,j))/(10./dt+1.)
   270: |           
   271: |                   ENDIF
   272: |          
   273: |                CASE ( 'none' )
   274: |          
   275: |                  ! evergreen species: no climatic senescence
   276: |          
   277: |                CASE default
   278: |          
   279: |                  WRITE(numout,*) 'turnover: don''t know how to treat this PFT.'
   280: |                  WRITE(numout,*) '  number: ',j
   281: |                  WRITE(numout,*) '  senescence type: ',pheno_crit%senescence_type(j)
   282: |                  STOP
   283: |          
   284: |                END SELECT
   285: |          
   286: |                !
   287: |                ! 3.2 drop leaves and roots, plus stems and fruits for grasses
   288: |                !
   289: |          
   290: |                IF ( tree(j) ) THEN
   291: |          
   292: |                  ! 3.2.1 trees
   293: |          
   294: |V----->           WHERE ( senescence(:,j) )
   295: ||         
   296: ||                   turnover(:,j,ileaf) = biomass(:,j,ileaf) * dt / pheno_crit%leaffall(j)
   297: ||                   turnover(:,j,iroot) = biomass(:,j,iroot) * dt / pheno_crit%leaffall(j)
   298: ||         
   299: ||                   biomass(:,j,ileaf) = biomass(:,j,ileaf) - turnover(:,j,ileaf)
   300: |V-----              biomass(:,j,iroot) = biomass(:,j,iroot) - turnover(:,j,iroot)
   301: |          
   302: |                  ENDWHERE
   303: |          
   304: |                ELSE
   305: |          
   306: |                  ! 3.2.2 grasses      
   307: |V----->            WHERE (turnover_time(:,j) .LT. pheno_crit%max_turnover_time(j)) 
   308: ||                     turnover(:,j,ileaf) = biomass(:,j,ileaf) * dt / turnover_time(:,j)
   309: ||                     turnover(:,j,isapabove) = biomass(:,j,isapabove) * dt / turnover_time(:,j)
   310: ||                     turnover(:,j,iroot) = biomass(:,j,iroot) * dt / turnover_time(:,j) 
   311: ||                     turnover(:,j,ifruit) = biomass(:,j,ifruit) * dt / turnover_time(:,j)
   312: ||                   ELSEWHERE
   313: ||                      turnover(:,j,ileaf)=0.0
   314: ||                      turnover(:,j,isapabove) =0.0
   315: ||                      turnover(:,j,iroot) = 0.0
   316: |V-----                 turnover(:,j,ifruit) =0.0
   317: |                    ENDWHERE
   318: |V----->             biomass(:,j,ileaf) = biomass(:,j,ileaf) - turnover(:,j,ileaf)
   319: ||                   biomass(:,j,isapabove) = biomass(:,j,isapabove) - turnover(:,j,isapabove)
   320: ||                   biomass(:,j,iroot) = biomass(:,j,iroot) - turnover(:,j,iroot)
   321: |V-----              biomass(:,j,ifruit) = biomass(:,j,ifruit) - turnover(:,j,ifruit)
   322: |          
   323: |                ENDIF      ! tree/grass
   324: |          
   325: +------        ENDDO        ! loop over PFTs
   326:               
   327:                !
   328:                ! 4 At a certain age, leaves fall off, even if the climate would allow a green plant
   329:                !     all year round.
   330:                !   Decay rate varies with leaf age.
   331:                !   Roots, fruits (and stems) follow leaves.
   332:                !   Note that plant is not declared senescent in this case (important for allocation:
   333:                !   if the plant loses leaves because of their age, it can renew them).
   334:                !
   335:            
   336: +------>       DO j = 1, npft
   337: |          
   338: |                ! save old leaf mass
   339: |V=====          lm_old(:) = biomass(:,j,ileaf)
   340: |          
   341: |                ! initialize leaf mass change in age class
   342: |+V====          delta_lm(:,:) = 0.0
   343: |          
   344: |                IF ( tree(j) ) THEN
   345: |          
   346: |                  !
   347: |                  ! 4.1 trees: leaves, roots, fruits
   348: |                  !            roots and fruits follow leaves.
   349: |                  !
   350: |          
   351: |                  ! 4.1.1 critical age: prescribed for trees
   352: |          
   353: |V=====            leaf_age_crit(:,j) = pheno_crit%leafagecrit(j)
   354: |          
   355: |                  ! 4.1.2 loop over leaf age classes
   356: |          
   357: |+----->           DO m = 1, nleafages
   358: ||V====              turnover_rate(:) =0 
   359: ||V---->             WHERE ( leaf_age(:,j,m) .GT. leaf_age_crit(:,j)/2. )
   360: |||          
   361: |||                    turnover_rate(:) =  &
   362: |||                      MIN( 0.99_r_std, dt / ( leaf_age_crit(:,j) * &
   363: |||                                        ( leaf_age_crit(:,j) / leaf_age(:,j,m) )**4._r_std ) )
   364: |||        
   365: |||                    dturnover(:) = biomass(:,j,ileaf) * leaf_frac(:,j,m) * turnover_rate(:)
   366: |||                    turnover(:,j,ileaf) = turnover(:,j,ileaf) + dturnover(:)
   367: |||                    biomass(:,j,ileaf) = biomass(:,j,ileaf) - dturnover(:)
   368: |||        
   369: |||                    ! save leaf mass change
   370: |||                    delta_lm(:,m) = - dturnover(:)
   371: |||          
   372: |||                    dturnover(:) = biomass(:,j,iroot) * leaf_frac(:,j,m) * turnover_rate(:)
   373: |||                    turnover(:,j,iroot) = turnover(:,j,iroot) + dturnover(:)
   374: |||                    biomass(:,j,iroot) = biomass(:,j,iroot) - dturnover(:)
   375: |||          
   376: |||                    dturnover(:) = biomass(:,j,ifruit) * leaf_frac(:,j,m) * turnover_rate(:)
   377: |||                    turnover(:,j,ifruit) = turnover(:,j,ifruit) + dturnover(:)
   378: ||V----                biomass(:,j,ifruit) = biomass(:,j,ifruit) - dturnover(:)
   379: ||           
   380: ||                   ENDWHERE
   381: ||         
   382: |+-----            ENDDO
   383: |          
   384: |                ELSE
   385: |          
   386: |                  !
   387: |                  ! 4.2 grasses: leaves, roots, fruits, sap.
   388: |                  !              roots, fruits, and sap follow leaves.
   389: |                  !
   390: |          
   391: |                  ! 4.2.1 critical leaf age depends on long-term temperature:
   392: |                  !       generally, lower turnover in cooler climates.
   393: |          
   394: |V=====            leaf_age_crit(:,j) = &
   395: |                     MIN( pheno_crit%leafagecrit(j) * 1.5_r_std , &
   396: |                            MAX( pheno_crit%leafagecrit(j) * 0.75_r_std, &
   397: |                                   pheno_crit%leafagecrit(j) - 10._r_std * &
   398: |                                     ( tlong_ref(:)-ZeroCelsius-20._r_std ) ) )
   399: |          
   400: |                  ! 4.2.2 loop over leaf age classes
   401: |          
   402: |+----->           DO m = 1, nleafages
   403: ||         
   404: ||V---->             WHERE ( leaf_age(:,j,m) .GT. leaf_age_crit(:,j)/2. )
   405: |||          
   406: |||                    turnover_rate(:) =  &
   407: |||                      MIN( 0.99_r_std, dt / ( leaf_age_crit(:,j) * &
   408: |||                                        ( leaf_age_crit(:,j) / leaf_age(:,j,m) )**4._r_std ) )
   409: |||          
   410: |||                    dturnover(:) = biomass(:,j,ileaf) * leaf_frac(:,j,m) * turnover_rate(:)
   411: |||                    turnover(:,j,ileaf) = turnover(:,j,ileaf) + dturnover(:)
   412: |||                    biomass(:,j,ileaf) = biomass(:,j,ileaf) - dturnover(:)
   413: |||        
   414: |||                    ! save leaf mass change
   415: |||                    delta_lm(:,m) = - dturnover(:)
   416: |||          
   417: |||                    dturnover(:) = biomass(:,j,isapabove) * leaf_frac(:,j,m) * turnover_rate(:)
   418: |||                    turnover(:,j,isapabove) = turnover(:,j,isapabove) + dturnover(:)
   419: |||                    biomass(:,j,isapabove) = biomass(:,j,isapabove) - dturnover(:)
   420: |||            
   421: |||                    dturnover(:) = biomass(:,j,iroot) * leaf_frac(:,j,m) * turnover_rate(:)
   422: |||                    turnover(:,j,iroot) = turnover(:,j,iroot) + dturnover(:)
   423: |||                    biomass(:,j,iroot) = biomass(:,j,iroot) - dturnover(:)
   424: |||            
   425: |||                    dturnover(:) = biomass(:,j,ifruit) * leaf_frac(:,j,m) * turnover_rate(:)
   426: |||                    turnover(:,j,ifruit) = turnover(:,j,ifruit) + dturnover(:)
   427: ||V----                biomass(:,j,ifruit) = biomass(:,j,ifruit) - dturnover(:)
   428: ||           
   429: ||                   ENDWHERE
   430: ||         
   431: ||         
   432: |+-----            ENDDO
   433: |            
   434: |                ENDIF       ! tree/grass ?
   435: |          
   436: |                !
   437: |                ! 4.3 recalculate fraction in each leaf age class
   438: |                !     new fraction = new leaf mass of that fraction / new total leaf mass
   439: |                !                  = ( old fraction*old total leaf mass + biomass change of that fraction ) /
   440: |                !                    new total leaf mass
   441: |                !
   442: |          
   443: |*----->         DO m = 1, nleafages
   444: ||         
   445: ||V---->           WHERE ( biomass(:,j,ileaf) .GT. 0.0 )
   446: |||                  leaf_frac(:,j,m) = ( leaf_frac(:,j,m)*lm_old(:) + delta_lm(:,m) ) / biomass(:,j,ileaf)
   447: |||                ELSEWHERE
   448: ||V----              leaf_frac(:,j,m) = 0.0
   449: ||                 ENDWHERE
   450: ||         
   451: |*-----          ENDDO 
   452: |          
   453: +------        ENDDO         ! loop over PFTs
   454:            
   455:                !
   456:                ! 5 new (provisional) lai
   457:                !
   458:            
   459:            !    DO j = 1, npft
   460:            
   461:            !      WHERE ( PFTpresent(:,j) )
   462:            !        lai(:,j) = biomass(:,j,ileaf) / veget_max(:,j) * sla(j)
   463:            !      ELSEWHERE
   464:            !        lai(:,j) = 0.0
   465:            !      ENDWHERE
   466:            !
   467:            !    ENDDO
   468:            
   469:                !
   470:                ! 6 definitely drop leaves if very low leaf mass during senescence.
   471:                !   Also drop fruits and loose fine roots.
   472:                !   Set lai to zero if necessary
   473:                !   Check whether leaf regrowth is immediately allowed.
   474:                !
   475:            
   476: +------>       DO j = 1, npft
   477: |          
   478: |V=====          shed_rest(:) = .FALSE.
   479: |          
   480: |                !
   481: |                ! 6.1 deciduous trees
   482: |                !
   483: |          
   484: |                IF ( tree(j) .AND. ( pheno_crit%senescence_type(j) .NE. 'none' ) ) THEN
   485: |          
   486: |                  ! check whether we shed the remaining leaves
   487: |          
   488: |V----->           WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. senescence(:,j) .AND. &
   489: ||                         ( biomass(:,j,ileaf) .LT. (pheno_crit%lai_initmin(j) / 2.)* veget_max(:,j)/sla(j) )             )
   490: ||         
   491: ||                   shed_rest(:) = .TRUE.
   492: ||         
   493: ||                   turnover(:,j,ileaf) = turnover(:,j,ileaf) + biomass(:,j,ileaf)
   494: ||                   turnover(:,j,iroot) = turnover(:,j,iroot) + biomass(:,j,iroot)
   495: ||                   turnover(:,j,ifruit) = turnover(:,j,ifruit) + biomass(:,j,ifruit)
   496: ||         
   497: ||                   biomass(:,j,ileaf) = 0.0
   498: ||                   biomass(:,j,iroot) = 0.0
   499: ||                   biomass(:,j,ifruit) = 0.0
   500: ||         
   501: ||         
   502: ||         
   503: ||                   ! reset leaf age
   504: |V-----              leaf_meanage(:,j) = 0.0
   505: |          
   506: |                  ENDWHERE
   507: |          
   508: |                ENDIF
   509: |          
   510: |                !
   511: |                ! 6.2 grasses: also convert stems
   512: |                !
   513: |          
   514: |                IF ( .NOT. tree(j) ) THEN
   515: |          
   516: |                  ! Shed the remaining leaves if LAI very low.
   517: |          
   518: |V----->           WHERE ( ( biomass(:,j,ileaf) .GT. 0.0 ) .AND. senescence(:,j) .AND. &
   519: ||                         (  biomass(:,j,ileaf) .LT. (pheno_crit%lai_initmin(j) / 2.)* veget_max(:,j)/sla(j) ))
   520: ||         
   521: ||                   shed_rest(:) = .TRUE.
   522: ||         
   523: ||                   turnover(:,j,ileaf) = turnover(:,j,ileaf) + biomass(:,j,ileaf)
   524: ||                   turnover(:,j,isapabove) = turnover(:,j,isapabove) + biomass(:,j,isapabove)
   525: ||                   turnover(:,j,iroot) = turnover(:,j,iroot) + biomass(:,j,iroot)
   526: ||                   turnover(:,j,ifruit) = turnover(:,j,ifruit) + biomass(:,j,ifruit)
   527: ||         
   528: ||                   biomass(:,j,ileaf) = 0.0
   529: ||                   biomass(:,j,isapabove) = 0.0
   530: ||                   biomass(:,j,iroot) = 0.0
   531: ||                   biomass(:,j,ifruit) = 0.0
   532: ||         
   533: ||         
   534: ||         
   535: ||                   ! reset leaf age
   536: |V-----              leaf_meanage(:,j) = 0.0
   537: |          
   538: |                  ENDWHERE
   539: |          
   540: |                ENDIF
   541: |          
   542: |                !
   543: |                ! 6.3 reset leaf age structure
   544: |                !
   545: |          
   546: |*----->         DO m = 1, nleafages
   547: ||         
   548: ||V---->           WHERE ( shed_rest(:) )
   549: |||        
   550: |||                  leaf_age(:,j,m) = 0.0
   551: ||V----              leaf_frac(:,j,m) = 0.0
   552: ||         
   553: ||                 ENDWHERE
   554: ||         
   555: |*-----          ENDDO
   556: |          
   557: +------        ENDDO
   558:            
   559:                !
   560:                ! 7 Elephants, cows, gazelles. No lions.
   561:                !   Does not modify leaf age structure.
   562:                !
   563:            
   564:                IF ( ok_herbivores ) THEN
   565:            
   566:                  ! herbivore activity allowed. Eat when there are leaves. Otherwise,
   567:                  ! there won't be many fruits anyway.
   568:            
   569: +------>         DO j = 1, npft
   570: |          
   571: |                  IF ( tree(j) ) THEN
   572: |          
   573: |                    ! trees: only leaves and fruits are affected
   574: |          
   575: |V----->             WHERE ( biomass(:,j,ileaf) .GT. 0.0 )
   576: ||         
   577: ||                     dturnover(:) = biomass(:,j,ileaf) * dt / herbivores(:,j)
   578: ||                     turnover(:,j,ileaf) = turnover(:,j,ileaf) + dturnover(:)
   579: ||                     biomass(:,j,ileaf) = biomass(:,j,ileaf) - dturnover(:)
   580: ||         
   581: ||                     dturnover(:) = biomass(:,j,ifruit) * dt / herbivores(:,j)
   582: ||                     turnover(:,j,ifruit) = turnover(:,j,ifruit) + dturnover(:)
   583: |V-----                biomass(:,j,ifruit) = biomass(:,j,ifruit) - dturnover(:)
   584: |          
   585: |                    ENDWHERE
   586: |          
   587: |                  ELSE
   588: |          
   589: |                    ! grasses: the whole biomass above the ground: leaves, fruits, stems
   590: |          
   591: |V=====               WHERE ( biomass(:,j,ileaf) .GT. 0.0 )
   592: |          
   593: |V----->                 WHERE ( (herbivores(:,j) .GT. 0.01) .AND. (herbivores(:,j) .LT. 100000.) )
   594: ||         
   595: ||                          dturnover(:) = biomass(:,j,ileaf) * dt / herbivores(:,j)
   596: ||                          turnover(:,j,ileaf) = turnover(:,j,ileaf) + dturnover(:)
   597: ||                          biomass(:,j,ileaf) = biomass(:,j,ileaf) - dturnover(:)
   598: ||         
   599: ||                          dturnover(:) = biomass(:,j,isapabove) * dt / herbivores(:,j)
   600: ||                          turnover(:,j,isapabove) = turnover(:,j,isapabove) + dturnover(:)
   601: ||                          biomass(:,j,isapabove) = biomass(:,j,isapabove) - dturnover(:)
   602: ||         
   603: ||                          dturnover(:) = biomass(:,j,ifruit) * dt / herbivores(:,j)
   604: ||                          turnover(:,j,ifruit) = turnover(:,j,ifruit) + dturnover(:)
   605: |V-----                     biomass(:,j,ifruit) = biomass(:,j,ifruit) - dturnover(:)
   606: |          
   607: |                        ENDWHERE
   608: |          
   609: |                     ENDWHERE
   610: |          
   611: |                  ENDIF  ! tree/grass?
   612: |          
   613: +------          ENDDO    ! loop over PFTs
   614:            
   615:                ENDIF
   616:            
   617:                !
   618:                ! 8 fruit turnover for trees
   619:                !
   620:            
   621: +------>       DO j = 1, npft
   622: |          
   623: |                IF ( tree(j) ) THEN
   624: |          
   625: |V----->           dturnover(:) = biomass(:,j,ifruit) * dt / tau_fruit(j)
   626: ||                 turnover(:,j,ifruit) = turnover(:,j,ifruit) + dturnover(:)
   627: |V-----            biomass(:,j,ifruit) = biomass(:,j,ifruit) - dturnover(:)
   628: |          !!$        turnover(:,j,ifruit) = biomass(:,j,ifruit) * dt / tau_fruit(j)
   629: |          !!$        biomass(:,j,ifruit) = biomass(:,j,ifruit) - turnover(:,j,ifruit)
   630: |          
   631: |                ENDIF
   632: |          
   633: +------        ENDDO
   634:            
   635:                !
   636:                ! 9 Conversion of sapwood to heartwood
   637:                !   This is not added to "turnover" as the biomass is not lost!
   638:                !
   639:            
   640: +------>       DO j = 1, npft
   641: |          
   642: |                IF ( tree(j) ) THEN
   643: |          
   644: |                  ! for age calculations
   645: |          
   646: |                  IF ( .NOT. control%ok_dgvm ) THEN
   647: |V=====              hw_old(:) = biomass(:,j,iheartabove) + biomass(:,j,iheartbelow)
   648: |                  ENDIF
   649: |          
   650: |                  !
   651: |                  ! 9.1 Calculate the rate of conversion and update masses
   652: |                  !
   653: |          
   654: |                  ! above the ground
   655: |          
   656: |V----->           sapconv(:) = biomass(:,j,isapabove) * dt / tau_sap(j)
   657: ||                 biomass(:,j,isapabove) = biomass(:,j,isapabove) - sapconv(:)
   658: ||                 biomass(:,j,iheartabove) =  biomass(:,j,iheartabove) + sapconv(:)
   659: ||         
   660: ||                 ! below the ground
   661: ||         
   662: ||                 sapconv(:) = biomass(:,j,isapbelow) * dt / tau_sap(j)
   663: ||                 biomass(:,j,isapbelow) = biomass(:,j,isapbelow) - sapconv(:)
   664: |V-----            biomass(:,j,iheartbelow) =  biomass(:,j,iheartbelow) + sapconv(:)
   665: |           
   666: |          
   667: |                  !
   668: |                  ! 9.2 If vegetation is not dynamic, identify the age of the heartwood 
   669: |                  !     to the age of the whole tree (otherwise, the age of the tree is
   670: |                  !     treated in the establishment routine).
   671: |                  !     Creation of new heartwood decreases the age of the plant.
   672: |                  !
   673: |          
   674: |                  IF ( .NOT. control%ok_dgvm ) THEN
   675: |          
   676: |V=====              hw_new(:) = biomass(:,j,iheartabove) + biomass(:,j,iheartbelow)
   677: |          
   678: |V----->             WHERE ( hw_new(:) .GT. 0.0 )
   679: ||         
   680: |V-----                age(:,j) = age(:,j) * hw_old(:)/hw_new(:)
   681: |          
   682: |                    ENDWHERE
   683: |          
   684: |                  ENDIF
   685: |          
   686: |                ENDIF
   687: |          
   688: +------        ENDDO
   689:            
   690:                !
   691:                ! history
   692:                !
   693:            
   694:                CALL histwrite (hist_id_stomate, 'LEAF_AGE', itime, &
   695:                                leaf_meanage, npts*npft, horipft_index)
   696:                CALL histwrite (hist_id_stomate, 'HERBIVORES', itime, &
   697:                                herbivores, npts*npft, horipft_index)
   698:            
   699:                IF (bavard.GE.4) WRITE(numout,*) 'Leaving turnover'
   700:            
   701:              END SUBROUTINE turn
   702:            
   703:            END MODULE stomate_turnover
